package exception;


import cliente.Cliente;

/**
 * <p>Title: ClienteNaoCadastradoException</p>
 * <p>Description: Exceo levantada quando um cliente no est no cadastro. </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Rafael Cavalcanti Ortolan
 * @version 1.0
 */

public class ClienteNaoCadastradoException extends Exception {


    private Cliente cliente;

    public ClienteNaoCadastradoException(Cliente cliente) {
        this.cliente = cliente;
    }

    /**
     * Mensagem de erro.
     *
     * @return uma string informando que o cliente no consta no cadastro.
     */
    public String getMessage() {
        return "Cliente no cadastrado: " + cliente.toString();
    }

    public Cliente getCliente() {
        return this.cliente;
    }

    public void setCliente(Cliente cliente) {
        this.cliente = cliente;
    }
}