package exception;


import produto.Produto;

/**
 * <p>Title: ProdutoNaoCadastradoException</p>
 * <p>Description: Exceo levantada quando um produto no est no cadastro. </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Mayerber Carvalho Neto
 * @version 1.0
 */

public class ProdutoNaoCadastradoException extends Exception {


    private Produto produto;

    public ProdutoNaoCadastradoException(Produto produto) {
        this.setProduto(produto);
    }

    /**
     * Mensagem de erro.
     *
     * @return uma string informando que o produto no consta no cadastro.
     */
    public String getMessage() {
        return "Produto no cadastrado: " + produto.toString();
    }

    public Produto getProduto() {
        return produto;
    }

    public void setProduto(Produto produto) {
        this.produto = produto;
    }
}