package gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import fachada.Fachada;

import cliente.Cliente;

import util.DadosResidenciais;
import javax.swing.border.*;
import funcionario.Funcionario;

import exception.ClienteJaCadastradoException;
import exception.PermissaoNegadaException;

/**
 * <p>Title: FrameCadastrarCliente</p>
 * <p>Description: Cadastra um Cliente</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: VipTeam</p>
 * @author Rafael Cavalcanti Ortolan
 * @version 1.0
 */

public class FrameCadastroCliente extends JFrame {

    private Fachada fachada;
    private Funcionario funcionario;

    public FrameCadastroCliente(Fachada fachada, Funcionario f) {
        try {
            this.fachada = fachada;
            this.funcionario = f;
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
    public static void main(String[] args) {
    }
    private void jbInit() throws Exception {
        border1 = BorderFactory.createEtchedBorder(Color.white,new Color(142,
                     142, 142));
        titledBorder1 = new TitledBorder(border1,"Cadastro Cliente");
        this.setBounds(70,70,450,330);
        this.setTitle("Cadastro Cliente");
        this.setResizable(false);
        this.getContentPane().setLayout(null);
        btnCadastrar.setBounds(new Rectangle(107, 223, 96, 27));
        btnCadastrar.setToolTipText("");
        btnCadastrar.setText("Cadastrar");
        btnCadastrar.addActionListener(new
            FrameCadastroCliente_btnCadastrar_actionAdapter(this));
        btnFechar.setBounds(new Rectangle(330, 223, 96, 27));
        btnFechar.setText("Fechar");
        btnFechar.addActionListener(new
            FrameCadastroCliente_btnFechar_actionAdapter(this));
        edtNome.setMaximumSize(new Dimension(100, 21));
        edtNome.setBounds(new Rectangle(117, 43, 276, 21));
        edtNome.addActionListener(new
            FrameCadastroCliente_edtNome_actionAdapter(this));
        edtBairro.setMaximumSize(new Dimension(100, 21));
        edtBairro.setBounds(new Rectangle(117, 99, 276, 21));
        edtReferencia.setMaximumSize(new Dimension(100, 21));
        edtReferencia.setBounds(new Rectangle(117, 155, 276, 21));
        edtEndereco.setMaximumSize(new Dimension(100, 21));
        edtEndereco.setBounds(new Rectangle(117, 71, 276, 21));
        lblReferencia.setText("Referencia:");
        lblReferencia.setBounds(new Rectangle(35, 156, 75, 17));
        lblBairro.setText("Bairro:");
        lblBairro.setBounds(new Rectangle(35, 101, 75, 17));
        lblNome.setText("Nome:");
        lblNome.setBounds(new Rectangle(35, 47, 75, 17));
        edtCidade.setMaximumSize(new Dimension(100, 21));
        edtCidade.setBounds(new Rectangle(117, 127, 81, 21));
        lblTelefone.setText("Telefone:");
        lblTelefone.setBounds(new Rectangle(213, 128, 75, 17));
        lblEndereco.setText("Endereco:");
        lblEndereco.setBounds(new Rectangle(35, 74, 75, 17));
        lblCidade.setText("Cidade:");
        lblCidade.setBounds(new Rectangle(35, 129, 75, 17));
        edtTelefone.setMaximumSize(new Dimension(100, 21));
        edtTelefone.setBounds(new Rectangle(287, 127, 106, 21));
        btnLimpar.addActionListener(new
            FrameCadastroCliente_btnLimpar_actionAdapter(this));
        btnLimpar.setText("Limpar");
        btnLimpar.addActionListener(new
            FrameCadastroCliente_btnLimpar_actionAdapter(this));
        btnLimpar.setBounds(new Rectangle(219, 223, 96, 27));
        jPanel1.setBorder(titledBorder1);
        jPanel1.setBounds(new Rectangle(2, 4, 436, 296));
        jPanel1.setLayout(null);
        jPanel1.add(edtBairro, null);
        jPanel1.add(lblTelefone, null);
        jPanel1.add(edtTelefone, null);
        jPanel1.add(edtNome, null);
        jPanel1.add(edtEndereco, null);
        jPanel1.add(edtCidade, null);
        jPanel1.add(edtReferencia, null);
        jPanel1.add(lblEndereco, null);
        jPanel1.add(lblBairro, null);
        jPanel1.add(lblCidade, null);
        jPanel1.add(lblReferencia, null);
        jPanel1.add(lblNome, null);
        jPanel1.add(btnLimpar, null);
        jPanel1.add(btnCadastrar, null);
        jPanel1.add(btnFechar, null);
        this.getContentPane().add(jPanel1, null);
    }
    JButton btnCadastrar = new JButton();
    JButton btnFechar = new JButton();
    JTextField edtNome = new JTextField();
    JTextField edtBairro = new JTextField();
    JTextField edtReferencia = new JTextField();
    JTextField edtEndereco = new JTextField();
    JLabel lblReferencia = new JLabel();
    JLabel lblBairro = new JLabel();
    JLabel lblNome = new JLabel();
    JTextField edtCidade = new JTextField();
    JLabel lblTelefone = new JLabel();
    JLabel lblEndereco = new JLabel();
    JLabel lblCidade = new JLabel();
    JTextField edtTelefone = new JTextField();
    JButton btnLimpar = new JButton();
    JPanel jPanel1 = new JPanel();
    Border border1;
    TitledBorder titledBorder1;
    void btnCadastrar_actionPerformed(ActionEvent e) {
        try {
            DadosResidenciais dadosResidenciais = new DadosResidenciais(
            this.edtEndereco.getText(),this.edtTelefone.getText(),
            this.edtBairro.getText(),this.edtReferencia.getText(),
            this.edtCidade.getText());
            Cliente c = new Cliente(this.edtNome.getText(),dadosResidenciais);
            this.fachada.inserir(funcionario,c);
            JOptionPane.showMessageDialog(this,"Cliente cadastrado"
            ,"Cadastro ok", JOptionPane.INFORMATION_MESSAGE);
        } catch (IllegalArgumentException ex) {
            JOptionPane.showMessageDialog(this,ex.getMessage(),
               "Falha no Cadastro",JOptionPane.ERROR_MESSAGE);
        } catch (PermissaoNegadaException ex) {
            JOptionPane.showMessageDialog(this,ex.getMessage(),
               "Falha no Cadastro",JOptionPane.ERROR_MESSAGE);
        } catch (ClienteJaCadastradoException ex) {
            JOptionPane.showMessageDialog(this,ex.getMessage(),
               "Falha no Cadastro",JOptionPane.ERROR_MESSAGE);
        }
    }

    void btnFechar_actionPerformed(ActionEvent e) {
        this.dispose();
    }

    void edtNome_actionPerformed(ActionEvent e) {

    }

    void btnLimpar_actionPerformed(ActionEvent e) {
        this.edtNome.setText("");
        this.edtEndereco.setText("");
        this.edtBairro.setText("");
        this.edtTelefone.setText("");
        this.edtReferencia.setText("");
        this.edtCidade.setText("");
    }

    void btnConsulta_actionPerformed(ActionEvent e) {
        FrameConsultaCliente consulta = new FrameConsultaCliente(this.fachada,
                this.funcionario);
        consulta.setBounds(100,100,550,600);
        consulta.show();
    }
}

class FrameCadastroCliente_btnCadastrar_actionAdapter implements
        java.awt.event.ActionListener {

    FrameCadastroCliente adaptee;

    FrameCadastroCliente_btnCadastrar_actionAdapter(FrameCadastroCliente
            adaptee) {

        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnCadastrar_actionPerformed(e);
    }
}

class FrameCadastroCliente_btnFechar_actionAdapter implements
        java.awt.event.ActionListener {

    FrameCadastroCliente adaptee;

    FrameCadastroCliente_btnFechar_actionAdapter(FrameCadastroCliente adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnFechar_actionPerformed(e);
    }
}

class FrameCadastroCliente_edtNome_actionAdapter implements
        java.awt.event.ActionListener {

    FrameCadastroCliente adaptee;

    FrameCadastroCliente_edtNome_actionAdapter(FrameCadastroCliente adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.edtNome_actionPerformed(e);
    }
}

class FrameCadastroCliente_btnLimpar_actionAdapter implements
        java.awt.event.ActionListener {

    FrameCadastroCliente adaptee;

    FrameCadastroCliente_btnLimpar_actionAdapter(FrameCadastroCliente adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnLimpar_actionPerformed(e);
    }
}