package gui;


import fachada.Fachada;
import produto.Produto;
import produto.RepositorioProdutos;
import pedido.Pedido;
import funcionario.Funcionario;
import cliente.Cliente;
import cliente.RepositorioClientes;
import util.DadosResidenciais;
import util.Iterator;
import exception.ProdutoNaoCadastradoException;
import exception.PermissaoNegadaException;
import exception.ClienteNaoCadastradoException;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.JTable;
import javax.swing.table.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class FrameCadastroPedidos extends JFrame {


    private Fachada fachada;
    private Funcionario operador;
    private String[] nomeColunas = {"Nome", "Tamanho", "Preo (R$)",
                                     "Descrio"};
    private boolean isAtualizacao = false;

    JPanel jPanel1 = new JPanel();
    Border border1;
    TitledBorder titledBorder1;
    JLabel lblTelefone = new JLabel();
    JTextField edtTelefone = new JTextField();
    JLabel lblTaxa = new JLabel();
    JTextField edtTaxaEntrega = new JTextField("0.00");
    JLabel lblProdutos = new JLabel();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTable tblProdutosDisponiveis = new JTable();
    DefaultTableModel tbmProdutosDisponiveis;
    DefaultTableModel tbmProdutosInclusos;
    JLabel lblProdutosInclusos = new JLabel();
    JTable tblProdutosInclusos = new JTable();
    JScrollPane jScrollPane2 = new JScrollPane();
    JLabel lblSubtotal = new JLabel();
    JTextField edtSubTotal = new JTextField();
    JLabel lblTotal = new JLabel();
    JTextField edtTotal = new JTextField();
    JButton btnInserir = new JButton();
    JButton btnRemover = new JButton();
    JButton btnCadastrar = new JButton();
    JButton btnRemoverTudo = new JButton();
    JButton btnFechar = new JButton();
    Pedido pedido;

    public FrameCadastroPedidos(Fachada fachada, Funcionario operador) {
        this.fachada = fachada;
        this.operador = operador;
        this.pedido = new Pedido();

        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
    public FrameCadastroPedidos(Fachada fachada, Funcionario operador,
            Pedido pedido) {
        this.fachada = fachada;
        this.operador = operador;
        this.pedido = pedido;
        this.isAtualizacao = true;

        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        border1 = BorderFactory.createEtchedBorder(Color.white,
                                                    new Color(148, 145, 140));
        titledBorder1 = new TitledBorder(border1,"Cadastro de Pedidos");
        this.getContentPane().setLayout(null);
        this.setBounds(0,0,440,555);
        this.setTitle("Cadastro de Pedidos");
        this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        this.setResizable(false);
        jPanel1.setBorder(titledBorder1);
        jPanel1.setBounds(new Rectangle(3, 1, 425, 525));
        jPanel1.setLayout(null);
        lblTelefone.setText("Telefone do cliente:");
        lblTelefone.setBounds(new Rectangle(16, 24, 123, 21));
        edtTelefone.setBounds(new Rectangle(147, 22, 87, 24));
        lblTaxa.setBounds(new Rectangle(177, 405, 124, 21));
        lblTaxa.setText("Taxa de entrega (R$):");
        edtTaxaEntrega.setBounds(new Rectangle(314, 403, 95, 24));
        edtTaxaEntrega.addFocusListener(new
                FrameCadastroPedidos_edtTaxaEntrega_focusAdapter(this));
        lblProdutos.setText("Produtos disponveis:");
        lblProdutos.setBounds(new Rectangle(16, 60, 136, 17));
        jScrollPane1.setBounds(new Rectangle(16, 81, 397, 109));
        lblProdutosInclusos.setBounds(new Rectangle(15, 225, 136, 17));
        lblProdutosInclusos.setText("Produtos inclusos:");
        jScrollPane2.setBounds(new Rectangle(14, 252, 397, 109));
        lblSubtotal.setText("Sub-total (R$):");
        lblSubtotal.setBounds(new Rectangle(218, 376, 87, 17));
        edtSubTotal.setEditable(false);
        edtSubTotal.setBounds(new Rectangle(314, 371, 95, 24));
        lblTotal.setBounds(new Rectangle(241, 438, 66, 17));
        lblTotal.setText("Total (R$):");
        edtTotal.setBounds(new Rectangle(314, 434, 95, 24));
        edtTotal.setEditable(false);
        btnInserir.setBounds(new Rectangle(225, 207, 86, 27));
        btnInserir.setText("Inserir");
        btnInserir.addActionListener(new
                FrameCadastroPedidos_btnInserir_actionAdapter(this));
        btnRemover.setText("Remover");
        btnRemover.addActionListener(new
                FrameCadastroPedidos_btnRemover_actionAdapter(this));
        btnRemover.setBounds(new Rectangle(327, 207, 86, 27));
        btnCadastrar.setBounds(new Rectangle(207, 488, 93, 27));
        btnCadastrar.setText("Cadastrar");
        btnCadastrar.addActionListener(new
                FrameCadastroPedidos_btnCadastrar_actionAdapter(this));
        btnRemoverTudo.setBounds(new Rectangle(14, 366, 115, 27));
        btnRemoverTudo.setText("Remover tudo");
        btnRemoverTudo.addActionListener(new
                FrameCadastroPedidos_btnRemoverTudo_actionAdapter(this));
        btnFechar.setBounds(new Rectangle(316, 488, 93, 27));
        btnFechar.setText("Fechar");
        btnFechar.addActionListener(new
                FrameCadastroPedidos_btnFechar_actionAdapter(this));
        jPanel1.add(edtTelefone, null);
        jPanel1.add(lblTelefone, null);
        jPanel1.add(lblProdutos, null);
        jPanel1.add(jScrollPane1, null);
        jPanel1.add(jScrollPane2, null);
        jPanel1.add(lblProdutosInclusos, null);
        jPanel1.add(btnRemover, null);
        jPanel1.add(btnInserir, null);
        jPanel1.add(edtSubTotal, null);
        jPanel1.add(lblTaxa, null);
        jPanel1.add(edtTaxaEntrega, null);
        jPanel1.add(edtTotal, null);
        jPanel1.add(lblSubtotal, null);
        jPanel1.add(lblTotal, null);
        jPanel1.add(btnRemoverTudo, null);
        jPanel1.add(btnCadastrar, null);
        jPanel1.add(btnFechar, null);
        jScrollPane2.getViewport().add(tblProdutosInclusos, null);
        jScrollPane1.getViewport().add(tblProdutosDisponiveis, null);
        this.getContentPane().add(jPanel1, null);

        tblProdutosDisponiveis.getTableHeader().setReorderingAllowed(false);
        tblProdutosDisponiveis.setSelectionMode(ListSelectionModel.
                SINGLE_SELECTION);
        tbmProdutosDisponiveis = new ModeloTabela(nomeColunas);
        tblProdutosDisponiveis.setModel(tbmProdutosDisponiveis);
        tblProdutosDisponiveis.getColumnModel().getColumn(0).
                setPreferredWidth(80);
        tblProdutosDisponiveis.getColumnModel().getColumn(1).
                setPreferredWidth(35);
        tblProdutosDisponiveis.getColumnModel().getColumn(2).
                setPreferredWidth(40);
        tblProdutosDisponiveis.getColumnModel().getColumn(3).
                setPreferredWidth(100);

        tblProdutosInclusos.getTableHeader().setReorderingAllowed(false);
        tblProdutosInclusos.setSelectionMode(ListSelectionModel.
                SINGLE_SELECTION);
        tbmProdutosInclusos = new ModeloTabela(nomeColunas);
        tblProdutosInclusos.setModel(tbmProdutosInclusos);
        tblProdutosInclusos.getColumnModel().getColumn(0).setPreferredWidth(80);
        tblProdutosInclusos.getColumnModel().getColumn(1).setPreferredWidth(35);
        tblProdutosInclusos.getColumnModel().getColumn(2).setPreferredWidth(40);
        tblProdutosInclusos.getColumnModel().getColumn(3).
                setPreferredWidth(100);

        if (this.operador != null) {
            atualizarProdutosDisponiveis();
            atualizarInformacoesPedido();
        }

        if (this.isAtualizacao == true) {
            edtTelefone.setEditable(false);
            edtTelefone.setText(pedido.getCliente().getDadosResidenciais().
                    getTelefone());
            btnCadastrar.setText("Atualizar");
        }

    }

    private void atualizarProdutosDisponiveis() {
        Object[] linha;
        Produto prod = new Produto();
        RepositorioProdutos repProdutos;
        Iterator iterador;

        repProdutos = this.fachada.match(this.operador, prod, 0);
        iterador = repProdutos.getIterator();

        tbmProdutosDisponiveis.setRowCount(0);
        while (iterador.hasNext()) {
            prod = ((Produto) iterador.next());

            linha = new Object[4];
            linha[0] = prod.getNome();
            linha[1] = Produto.descricaoTamanho[prod.getTamanho()];
            linha[2] = new Float(prod.getPreco());
            linha[3] = prod.getDescricao();
            tbmProdutosDisponiveis.addRow(linha);
        }
    }

    void atualizarInformacoesPedido() {
        Object[] linha;
        Produto prod = new Produto();
        Iterator iterador;

        edtSubTotal.setText(Float.toString(this.pedido.getSubTotal()));
        edtTotal.setText(Float.toString(this.pedido.getTotal()));

        iterador = this.pedido.getProdutos().getIterator();

        tbmProdutosInclusos.setRowCount(0);
        while (iterador.hasNext()) {
            prod = ((Produto) iterador.next());

            linha = new Object[4];
            linha[0] = prod.getNome();
            linha[1] = Produto.descricaoTamanho[prod.getTamanho()];
            linha[2] = new Float(prod.getPreco());
            linha[3] = prod.getDescricao();
            tbmProdutosInclusos.addRow(linha);
        }
    }

    void btnFechar_actionPerformed(ActionEvent e) {
        this.dispose();
    }

    void btnInserir_actionPerformed(ActionEvent e) {
        int selRow = tblProdutosDisponiveis.getSelectedRow();
        Produto prod = new Produto();

        if (selRow == -1) {
            JOptionPane.showMessageDialog(this, "Selecione um produto.",
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
        } else {
            prod.setNome((String) tbmProdutosDisponiveis.getValueAt(selRow, 0));
            prod.setTamanho(getTamanhoPelaDescricao((String)
                    tbmProdutosDisponiveis.getValueAt(selRow, 1)));
            prod.setPreco(((Float) tbmProdutosDisponiveis.
                    getValueAt(selRow, 2)).floatValue());
            prod.setDescricao((String) tbmProdutosDisponiveis.
                    getValueAt(selRow, 3));
            this.pedido.getProdutos().inserir(prod);
            this.atualizarInformacoesPedido();
        }
    }

    private int getTamanhoPelaDescricao(String descricaoTamanho) {
        int ret;

        for (ret = 0; ret < Produto.descricaoTamanho.length; ret++) {
            if (Produto.descricaoTamanho[ret].equals(descricaoTamanho)) {
                break;
            }
        }

        return ret;
    }

    void btnRemover_actionPerformed(ActionEvent e) {
        int selRow = tblProdutosInclusos.getSelectedRow();
        Produto prod = new Produto();

        if (selRow == -1) {
            JOptionPane.showMessageDialog(this, "Selecione um produto.",
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
        } else {
            try {
                prod.setNome((String)
                        tbmProdutosInclusos.getValueAt(selRow, 0));
                prod.setTamanho(getTamanhoPelaDescricao((String)
                        tbmProdutosInclusos.getValueAt(selRow, 1)));
                this.pedido.getProdutos().remover(prod);
                this.atualizarInformacoesPedido();
            } catch (IllegalArgumentException ex) {
                JOptionPane.showMessageDialog(this, ex.getMessage(),
                                                this.getTitle(),
                                                JOptionPane.ERROR_MESSAGE);
            }
        }

    }

    void btnRemoverTudo_actionPerformed(ActionEvent e) {
        Produto prod = new Produto();
        Iterator iterador;

        iterador = this.pedido.getProdutos().getIterator();

        while (iterador.hasNext()) {
            prod = ((Produto) iterador.next());
            this.pedido.getProdutos().remover(prod);
        }

        this.atualizarInformacoesPedido();
    }

    void btnCadastrar_actionPerformed(ActionEvent e) {
        String telefone = edtTelefone.getText();
        String taxaEntrega = edtTaxaEntrega.getText();
        DadosResidenciais dr = new DadosResidenciais();
        Cliente cliente = new Cliente();
        RepositorioClientes repClientes;
        Iterator iterador;
        float te;

        try {
            dr.setTelefone(telefone);
            cliente.setDadosResidenciais(dr);
            repClientes = this.fachada.match(operador, cliente,
                                            Cliente.MATCH_TELEFONE);
            if (repClientes.eVazio()) {
                this.pedido.setCliente(cliente);
            } else {
                iterador = repClientes.getIterator();
                this.pedido.setCliente((Cliente) iterador.next());
            }
            te = Float.parseFloat(taxaEntrega);
            this.pedido.setTaxaEntrega(te);
            this.pedido.setFuncionario(operador);
            if (this.isAtualizacao == true) {
                this.fachada.atualizar(this.operador, this.pedido);
                JOptionPane.showMessageDialog(this, "Pedido Atualizado",
                                            this.getTitle(),
                                            JOptionPane.INFORMATION_MESSAGE);
                this.dispose();
            } else {
                this.fachada.inserir(operador, pedido);
                JOptionPane.showMessageDialog(this, "Pedido Cadastrado",
                                            this.getTitle(),
                                            JOptionPane.INFORMATION_MESSAGE);
            }
            this.pedido = new Pedido();
            atualizarInformacoesPedido();
            edtTelefone.setText("");
        } catch (NumberFormatException ex) {
            JOptionPane.showMessageDialog(this, "Taxa de entrega invlida",
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
        } catch (ProdutoNaoCadastradoException ex) {
            JOptionPane.showMessageDialog(this, ex.getMessage(),
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
        } catch (PermissaoNegadaException ex) {
            JOptionPane.showMessageDialog(this, ex.getMessage(),
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
        } catch (ClienteNaoCadastradoException ex) {
            JOptionPane.showMessageDialog(this, ex.getMessage(),
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
        } catch (IllegalArgumentException ex) {
            JOptionPane.showMessageDialog(this, ex.getMessage(),
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
        }
    }
}

class FrameCadastroPedidos_btnFechar_actionAdapter implements
            java.awt.event.ActionListener {
    FrameCadastroPedidos adaptee;

    FrameCadastroPedidos_btnFechar_actionAdapter(FrameCadastroPedidos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnFechar_actionPerformed(e);
    }
}

class ModeloTabela extends DefaultTableModel {
    public ModeloTabela(String[] nomeColunas) {
        super(nomeColunas, 0);
    }

    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return false;
    }

    public Class getColumnClass(int c) {
        Class ret;

        if (c == 2) {
            ret = Float.class;
        } else {
            ret = String.class;
        }

        return ret;
    }
}

class FrameCadastroPedidos_btnInserir_actionAdapter implements
            java.awt.event.ActionListener {
    FrameCadastroPedidos adaptee;

    FrameCadastroPedidos_btnInserir_actionAdapter(FrameCadastroPedidos
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnInserir_actionPerformed(e);
    }
}

class FrameCadastroPedidos_edtTaxaEntrega_focusAdapter extends FocusAdapter {
    FrameCadastroPedidos adaptee;

    FrameCadastroPedidos_edtTaxaEntrega_focusAdapter(FrameCadastroPedidos
            adaptee) {
        this.adaptee = adaptee;
    }

    public void focusLost(FocusEvent e) {
        if (e.isTemporary() == false) {
            String tmp = adaptee.edtTaxaEntrega.getText();

            try {
                float te = Float.parseFloat(tmp);

                adaptee.pedido.setTaxaEntrega(te);
                adaptee.atualizarInformacoesPedido();
            } catch (NumberFormatException ex) {
                JOptionPane.showMessageDialog(adaptee,
                                            "Taxa de entrega invlida",
                                            adaptee.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
            } catch (IllegalArgumentException ex) {
                JOptionPane.showMessageDialog(adaptee, ex.getMessage(),
                                            adaptee.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
            }
        }
    }
}

class FrameCadastroPedidos_btnRemover_actionAdapter implements
            java.awt.event.ActionListener {
    FrameCadastroPedidos adaptee;

    FrameCadastroPedidos_btnRemover_actionAdapter(FrameCadastroPedidos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnRemover_actionPerformed(e);
    }
}

class FrameCadastroPedidos_btnRemoverTudo_actionAdapter implements
            java.awt.event.ActionListener {
    FrameCadastroPedidos adaptee;

    FrameCadastroPedidos_btnRemoverTudo_actionAdapter(FrameCadastroPedidos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnRemoverTudo_actionPerformed(e);
    }
}

class FrameCadastroPedidos_btnCadastrar_actionAdapter implements
            java.awt.event.ActionListener {
    FrameCadastroPedidos adaptee;

    FrameCadastroPedidos_btnCadastrar_actionAdapter(FrameCadastroPedidos
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnCadastrar_actionPerformed(e);
    }
}