package gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;

import fachada.Fachada;
import produto.Produto;
import funcionario.Funcionario;
import exception.ProdutoJaCadastradoException;
import exception.PermissaoNegadaException;

/**
 * <p>Title: FrameCadastroProdutos</p>
 * <p>Description: Tela de Cadastro de Produtos</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Mayerber Carvalho Neto
 * @version 1.0
 */

public class FrameCadastroProdutos extends JFrame {


    private Fachada fachada;
    private Funcionario operador;

    JPanel jPanel1 = new JPanel();
    Border border1;
    TitledBorder titledBorder1;
    JTextField edtNome = new JTextField();
    JLabel lblNome = new JLabel();
    JComboBox cmbTamanho = new JComboBox();
    JLabel lblTamanho = new JLabel();
    JTextField edtPreco = new JTextField();
    JLabel lblPreco = new JLabel();
    JLabel lblDescricao = new JLabel();
    JTextField edtDescricao = new JTextField();
    JButton btnCadastrar = new JButton();
    JButton btnFechar = new JButton();
    JButton btnLimpar = new JButton();

    public FrameCadastroProdutos(Fachada fachada, Funcionario operador) {
        this.fachada = fachada;
        this.operador = operador;

        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
    private void jbInit() throws Exception {
        border1 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
        titledBorder1 = new TitledBorder(border1,"Cadastro de Produtos");
        this.setResizable(false);
        this.setTitle("Cadastro de Produtos");
        this.getContentPane().setLayout(null);
        this.setBounds(0,0,410,240);
        jPanel1.setFont(new java.awt.Font("Dialog", 1, 12));
        jPanel1.setBorder(titledBorder1);
        jPanel1.setBounds(new Rectangle(2, 4, 398, 197));
        jPanel1.setLayout(null);
        edtNome.setBounds(new Rectangle(104, 23, 274, 21));
        lblNome.setText("Nome:");
        lblNome.setBounds(new Rectangle(13, 25, 41, 17));
        cmbTamanho.setBounds(new Rectangle(104, 54, 274, 21));
        lblTamanho.setText("Tamanho:");
        lblTamanho.setBounds(new Rectangle(13, 56, 73, 17));
        edtPreco.setBounds(new Rectangle(104, 86, 274, 21));
        lblPreco.setText("Preo (R$):");
        lblPreco.setBounds(new Rectangle(13, 88, 67, 17));
        lblDescricao.setText("Descrio:");
        lblDescricao.setBounds(new Rectangle(13, 120, 75, 17));
        edtDescricao.setBounds(new Rectangle(104, 118, 274, 21));
        btnCadastrar.setBounds(new Rectangle(64, 156, 93, 27));
        btnCadastrar.setText("Cadastrar");
        btnCadastrar.addActionListener(new FrameCadastroProdutos_btnCadastrar_actionAdapter(this));
        btnFechar.setBounds(new Rectangle(285, 156, 93, 27));
        btnFechar.setText("Fechar");
        btnFechar.addActionListener(new FrameCadastroProdutos_btnFechar_actionAdapter(this));
        btnLimpar.setText("Limpar");
        btnLimpar.addActionListener(new FrameCadastroProdutos_btnLimpar_actionAdapter(this));
        btnLimpar.setBounds(new Rectangle(174, 156, 93, 27));
        jPanel1.add(edtNome, null);
        jPanel1.add(lblNome, null);
        jPanel1.add(cmbTamanho, null);
        jPanel1.add(lblTamanho, null);
        jPanel1.add(lblPreco, null);
        jPanel1.add(lblDescricao, null);
        jPanel1.add(edtPreco, null);
        jPanel1.add(edtDescricao, null);
        jPanel1.add(btnLimpar, null);
        jPanel1.add(btnFechar, null);
        jPanel1.add(btnCadastrar, null);
        this.getContentPane().add(jPanel1, null);
        cmbTamanho.addItem(Produto.descricaoTamanho[0]);
        cmbTamanho.addItem(Produto.descricaoTamanho[1]);
        cmbTamanho.addItem(Produto.descricaoTamanho[2]);
        cmbTamanho.addItem(Produto.descricaoTamanho[3]);
        cmbTamanho.addItem(Produto.descricaoTamanho[4]);
    }

    void btnFechar_actionPerformed(ActionEvent e) {
        this.dispose();
    }

    void btnCadastrar_actionPerformed(ActionEvent e) {
        String nome = edtNome.getText();
        int tamanho = cmbTamanho.getSelectedIndex();
        String preco = edtPreco.getText();
        String desc = edtDescricao.getText();

        try {
            Float precofloat = new Float(preco);
            Produto prod = new Produto(nome,desc,tamanho,precofloat.floatValue());

            fachada.inserir(this.operador, prod);
            JOptionPane.showMessageDialog(this, "Produto cadastrado.",
                                        this.getTitle(),
                                        JOptionPane.INFORMATION_MESSAGE);
        } catch (NumberFormatException ex) {
            JOptionPane.showMessageDialog(this, "Preo invlido.",
                                        this.getTitle(),
                                        JOptionPane.ERROR_MESSAGE);
        } catch (PermissaoNegadaException ex) {
            JOptionPane.showMessageDialog(this, ex.getMessage(),
                                        this.getTitle(),
                                        JOptionPane.ERROR_MESSAGE);
        } catch (ProdutoJaCadastradoException ex) {
            JOptionPane.showMessageDialog(this, ex.getMessage(),
                                        this.getTitle(),
                                        JOptionPane.ERROR_MESSAGE);
        } catch (IllegalArgumentException ex) {
            JOptionPane.showMessageDialog(this, ex.getMessage(),
                                        this.getTitle(),
                                        JOptionPane.ERROR_MESSAGE);
        }
    }

    void btnLimpar_actionPerformed(ActionEvent e) {
        edtNome.setText("");
        cmbTamanho.setSelectedIndex(0);
        edtPreco.setText("");
        edtDescricao.setText("");
    }
}

class FrameCadastroProdutos_btnCadastrar_actionAdapter implements java.awt.event.ActionListener {
    FrameCadastroProdutos adaptee;

    FrameCadastroProdutos_btnCadastrar_actionAdapter(FrameCadastroProdutos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnCadastrar_actionPerformed(e);
    }
}

class FrameCadastroProdutos_btnLimpar_actionAdapter implements java.awt.event.ActionListener {
    FrameCadastroProdutos adaptee;

    FrameCadastroProdutos_btnLimpar_actionAdapter(FrameCadastroProdutos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnLimpar_actionPerformed(e);
    }
}

class FrameCadastroProdutos_btnFechar_actionAdapter implements java.awt.event.ActionListener {
    FrameCadastroProdutos adaptee;

    FrameCadastroProdutos_btnFechar_actionAdapter(FrameCadastroProdutos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnFechar_actionPerformed(e);
    }
}
