package gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.table.*;

import fachada.Fachada;

import funcionario.Funcionario;

import cliente.Cliente;
import cliente.RepositorioClientes;

import util.Iterator;

import exception.ClienteNaoCadastradoException;
import exception.PermissaoNegadaException;

/**
 * <p>Title: FrameConsultarCliente</p>
 * <p>Description: Consulta um Cliente</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: VipTeam</p>
 * @author Rafael Cavalcanti Ortolan
 * @version 1.0
 */

public class FrameConsultaCliente extends JFrame {

    private Fachada fachada;
    private Funcionario funcionario;
    private String[] nomesCol = {"Nome","Endereo","Bairro","Cidade","Telefone",
            "Referncia"};
    private DefaultTableModel modeloTabela;

    JPanel jPanel1 = new JPanel();
    Border border1;
    TitledBorder titledBorder1;
    JButton btnConsulta = new JButton();
    JButton btnFechar = new JButton();
    JTextField edtBairro = new JTextField();
    JTextField edtTelefone = new JTextField();
    JTextField edtNome = new JTextField();
    JCheckBox chbNome = new JCheckBox();
    JCheckBox chbBairro = new JCheckBox();
    JCheckBox chbTelefone = new JCheckBox();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTable tblResultado = new JTable();
    JTextField edtCidade = new JTextField();
    JCheckBox chbCidade = new JCheckBox();
    JCheckBox chbEndereco = new JCheckBox();
    JTextField edtEndereco = new JTextField();
    JButton btnEdita = new JButton();
    JButton btnLimpar = new JButton();
    JButton btnRemover = new JButton();

    public FrameConsultaCliente(Fachada f, Funcionario funcionario) {
        try {
            this.fachada = f;
            this.funcionario = funcionario;
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
    public static void main(String[] args) {

    }
    private void jbInit() throws Exception {
        border1 = BorderFactory.createEtchedBorder(Color.white,new Color(142,
             142, 142));
        titledBorder1 = new TitledBorder(border1,"Consulta Cliente");
        this.setBounds(70,70,500,530);
        this.setResizable(false);
        this.setTitle("Consulta Cliente");
        this.getContentPane().setLayout(null);
        jPanel1.setBorder(titledBorder1);
        jPanel1.setBounds(new Rectangle(8, 9, 480, 485));
        jPanel1.setLayout(null);
        btnConsulta.setBounds(new Rectangle(255, 191, 90, 31));
        btnConsulta.setText("Consulta");
        btnConsulta.addActionListener(new
                FrameConsultaCliente_btnConsulta_actionAdapter(this));
        btnFechar.setText("Fechar");
        btnFechar.addActionListener(new
                FrameConsultaCliente_btnFechar_actionAdapter(this));
        btnFechar.setBounds(new Rectangle(360, 191, 90, 31));
        edtBairro.setMaximumSize(new Dimension(100, 21));
        edtBairro.setBounds(new Rectangle(116, 88, 80, 21));
        edtTelefone.setMaximumSize(new Dimension(100, 21));
        edtTelefone.setBounds(new Rectangle(301, 88, 106, 21));
        edtNome.setMaximumSize(new Dimension(100, 21));
        edtNome.setBounds(new Rectangle(116, 49, 291, 21));
//        edtNome.addActionListener(new
//            frameConsultaCliente_edtNome_actionAdapter(this));
        chbNome.setText("Nome:");
        chbNome.setBounds(new Rectangle(15, 46, 93, 25));
        chbBairro.setText("Bairro:");
        chbBairro.setBounds(new Rectangle(15, 82, 93, 25));
        chbTelefone.setText("Telefone:");
        chbTelefone.setBounds(new Rectangle(204, 86, 93, 25));
        jScrollPane1.setBounds(new Rectangle(27, 240, 425, 187));
        edtCidade.setBounds(new Rectangle(116, 126, 291, 21));
        edtCidade.setMaximumSize(new Dimension(100, 21));
        chbCidade.setBounds(new Rectangle(15, 119, 93, 25));
        chbCidade.setText("Cidade:");
        chbEndereco.setText("Endereo:");
        chbEndereco.setBounds(new Rectangle(15, 155, 93, 25));
        edtEndereco.setMaximumSize(new Dimension(100, 21));
        edtEndereco.setBounds(new Rectangle(116, 156, 291, 21));
        btnEdita.setBounds(new Rectangle(255, 439, 90, 31));
        btnEdita.setText("Edita");
        btnEdita.addActionListener(new
                FrameConsultaCliente_btnEdita_actionAdapter(this));
        btnLimpar.addActionListener(new
                FrameConsultaCliente_btnLimpar_actionAdapter(this));
        btnLimpar.setText("Limpar");
        btnLimpar.addActionListener(new
                FrameConsultaCliente_btnLimpar_actionAdapter(this));
        btnLimpar.setBounds(new Rectangle(150, 191, 90, 31));
        btnRemover.setBounds(new Rectangle(362, 439, 90, 31));
        btnRemover.setText("Remover");
        btnRemover.addActionListener(new
                FrameConsultaCliente_btnRemover_actionAdapter(this));
        jPanel1.add(edtNome, null);
        jPanel1.add(chbNome, null);
        jPanel1.add(edtBairro, null);
        jPanel1.add(chbBairro, null);
        jPanel1.add(edtTelefone, null);
        jPanel1.add(chbTelefone, null);
        this.getContentPane().add(jPanel1, null);
        jPanel1.add(edtCidade, null);
        jPanel1.add(chbCidade, null);
        jPanel1.add(chbEndereco, null);
        jPanel1.add(edtEndereco, null);
        jPanel1.add(btnFechar, null);
        jPanel1.add(btnConsulta, null);
        jPanel1.add(jScrollPane1, null);
        jPanel1.add(btnEdita, null);
        jPanel1.add(btnLimpar, null);
        jPanel1.add(btnRemover, null);
        jScrollPane1.getViewport().add(tblResultado, null);
        tblResultado.getTableHeader().setReorderingAllowed(false);
        modeloTabela = new DefaultTableModel(nomesCol,0) {
            public boolean isCellEditable(int x, int y) {
                if (y == 0 | y ==4) {
                    return false;
                }
                else {
                    return true;
                }
            }
        };
       tblResultado.setModel(modeloTabela);
    }

    void btnConsulta_actionPerformed(ActionEvent e) {
        int criterios = 0;
        int i;
        Cliente c = new Cliente();
        Cliente cliente;
        RepositorioClientes clientes;
        Iterator iterador;

        try {
            if (chbNome.isSelected()) {
                criterios = criterios | Cliente.MATCH_NOME;
                c.setNome(edtNome.getText());
            }
            if (chbTelefone.isSelected()) {
                criterios = criterios | Cliente.MATCH_TELEFONE;
                c.getDadosResidenciais().setTelefone(edtTelefone.getText());
            }
            if (chbBairro.isSelected()) {
                criterios = criterios | Cliente.MATCH_BAIRRO;
                c.getDadosResidenciais().setBairro(edtBairro.getText());
            }
            if (chbCidade.isSelected()) {
                criterios = criterios | Cliente.MATCH_CIDADE;
                c.getDadosResidenciais().setCidade(edtCidade.getText());
            }
            if (chbEndereco.isSelected()) {
                criterios = criterios | Cliente.MATCH_ENDERECO;
                c.getDadosResidenciais().setEndereco(edtEndereco.getText());
            }
            clientes = fachada.match(funcionario,c,criterios);
            iterador = clientes.getIterator();
            this.modeloTabela.setNumRows(0);
            i = 0;
            while (iterador.hasNext()) {
                modeloTabela.setRowCount(i+1);
                cliente = (Cliente) iterador.next();
                tblResultado.setValueAt(cliente.getNome(), i, 0);
                tblResultado.setValueAt(cliente.getDadosResidenciais().
                        getEndereco(), i, 1);
                tblResultado.setValueAt(cliente.getDadosResidenciais().
                        getBairro(), i, 2);
                tblResultado.setValueAt(cliente.getDadosResidenciais().
                        getCidade(), i, 3);
                tblResultado.setValueAt(cliente.getDadosResidenciais().
                        getTelefone(), i, 4);
                tblResultado.setValueAt(cliente.getDadosResidenciais().
                        getReferencia(), i, 5);
                i++;
            }
        } catch (IllegalArgumentException ex) {
            JOptionPane.showMessageDialog(this,ex.getMessage(),
                "Falha na Consulta",JOptionPane.ERROR_MESSAGE);
        }
    }

    void btnFechar_actionPerformed(ActionEvent e) {
        this.dispose();
    }

    void btnEdita_actionPerformed(ActionEvent e) {
        if (tblResultado.getSelectedRow() < 0) {
            JOptionPane.showMessageDialog(this,
                "Selecione alguma linha para Editar",
                "Falha na Edio",JOptionPane.ERROR_MESSAGE);
        }
        else {
            try {
                Cliente c = new Cliente();
                c.setNome(tblResultado.getValueAt(tblResultado.
                        getSelectedRow(),0).toString());
                c.getDadosResidenciais().setEndereco(tblResultado.
                        getValueAt(tblResultado.getSelectedRow(),1).toString());
                c.getDadosResidenciais().setBairro(tblResultado.
                        getValueAt(tblResultado.getSelectedRow(),2).toString());
                c.getDadosResidenciais().setCidade(tblResultado.
                        getValueAt(tblResultado.getSelectedRow(),3).toString());
                c.getDadosResidenciais().setTelefone(tblResultado.
                        getValueAt(tblResultado.getSelectedRow(),4).toString());
                c.getDadosResidenciais().setReferencia(tblResultado.
                        getValueAt(tblResultado.getSelectedRow(),5).toString());
                fachada.atualizar(funcionario,c);
                JOptionPane.showMessageDialog(this,
                    "Cliente Editado","Edio ok",
                    JOptionPane.INFORMATION_MESSAGE);
            } catch (IllegalArgumentException ex) {
                JOptionPane.showMessageDialog(this,ex.getMessage(),
                    "Falha na Edio",JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    void btnRemove_actionPerformed(ActionEvent e) {
        if (tblResultado.getSelectedRow() < 0) {
            JOptionPane.showMessageDialog(this,
                "Selecione alguma linha para Remover",
                "Falha na Remoo",JOptionPane.ERROR_MESSAGE);
        }
        else {
            try {
                Cliente c = new Cliente();
                c.setNome(tblResultado.getValueAt(tblResultado.
                        getSelectedRow(),0).toString());
                c.getDadosResidenciais().setEndereco(tblResultado.
                        getValueAt(tblResultado.getSelectedRow(),1).toString());
                c.getDadosResidenciais().setBairro(tblResultado.
                        getValueAt(tblResultado.getSelectedRow(),2).toString());
                c.getDadosResidenciais().setCidade(tblResultado.
                        getValueAt(tblResultado.getSelectedRow(),3).toString());
                c.getDadosResidenciais().setTelefone(tblResultado.
                        getValueAt(tblResultado.getSelectedRow(),4).toString());
                c.getDadosResidenciais().setReferencia(tblResultado.
                        getValueAt(tblResultado.getSelectedRow(),5).toString());
                fachada.remover(funcionario,c);
                this.modeloTabela.removeRow(tblResultado.getSelectedRow());
                JOptionPane.showMessageDialog(this,"Cliente Removido",
                    "Remoo ok",
                    JOptionPane.INFORMATION_MESSAGE);
            } catch (IllegalArgumentException ex) {
                JOptionPane.showMessageDialog(this,ex.getMessage(),
                    "Falha na Remoo",JOptionPane.ERROR_MESSAGE);
            } catch (PermissaoNegadaException ex) {
                JOptionPane.showMessageDialog(this,ex.getMessage(),
                   "Falha no Cadastro",JOptionPane.ERROR_MESSAGE);
            } catch (ClienteNaoCadastradoException ex) {
                JOptionPane.showMessageDialog(this,ex.getMessage(),
                   "Falha no Cadastro",JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    void btnLimpar_actionPerformed(ActionEvent e) {
        this.edtNome.setText("");
        this.edtEndereco.setText("");
        this.edtBairro.setText("");
        this.edtTelefone.setText("");
        this.edtCidade.setText("");
        this.chbBairro.setSelected(false);
        this.chbCidade.setSelected(false);
        this.chbEndereco.setSelected(false);
        this.chbNome.setSelected(false);
        this.chbTelefone.setSelected(false);
        this.modeloTabela.setNumRows(0);
    }

    void btnRemover_actionPerformed(ActionEvent e) {
        if (tblResultado.getSelectedRow() < 0) {
            JOptionPane.showMessageDialog(this,
                "Selecione alguma linha para Remover",
                "Falha na Remoo",JOptionPane.ERROR_MESSAGE);
        }
        else {
            try {
                Cliente c = new Cliente();
                c.setNome(tblResultado.getValueAt(tblResultado.
                    getSelectedRow(),0).toString());
                c.getDadosResidenciais().setEndereco(tblResultado.
                    getValueAt(tblResultado.getSelectedRow(),1).toString());
                c.getDadosResidenciais().setBairro(tblResultado.
                    getValueAt(tblResultado.getSelectedRow(),2).toString());
                c.getDadosResidenciais().setCidade(tblResultado.
                    getValueAt(tblResultado.getSelectedRow(),3).toString());
                c.getDadosResidenciais().setTelefone(tblResultado.
                    getValueAt(tblResultado.getSelectedRow(),4).toString());
                c.getDadosResidenciais().setReferencia(tblResultado.
                    getValueAt(tblResultado.getSelectedRow(),5).toString());
                fachada.remover(funcionario,c);
                this.modeloTabela.removeRow(tblResultado.getSelectedRow());
                JOptionPane.showMessageDialog(this,"Cliente Removido",
                    "Remoo ok",
                    JOptionPane.INFORMATION_MESSAGE);
            } catch (IllegalArgumentException ex) {
                JOptionPane.showMessageDialog(this,ex.getMessage(),
                    "Falha na Remoo",JOptionPane.ERROR_MESSAGE);
            } catch (PermissaoNegadaException ex) {
                JOptionPane.showMessageDialog(this,ex.getMessage(),
                   "Falha no Cadastro",JOptionPane.ERROR_MESSAGE);
            } catch (ClienteNaoCadastradoException ex) {
                JOptionPane.showMessageDialog(this,ex.getMessage(),
                   "Falha no Cadastro",JOptionPane.ERROR_MESSAGE);
            }
        }
    }

}

class FrameConsultaCliente_btnConsulta_actionAdapter implements
        java.awt.event.ActionListener {
    FrameConsultaCliente adaptee;

    FrameConsultaCliente_btnConsulta_actionAdapter(FrameConsultaCliente
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnConsulta_actionPerformed(e);
    }
}

class FrameConsultaCliente_btnFechar_actionAdapter implements
        java.awt.event.ActionListener {
    FrameConsultaCliente adaptee;

    FrameConsultaCliente_btnFechar_actionAdapter(FrameConsultaCliente adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnFechar_actionPerformed(e);
    }
}

class FrameConsultaCliente_btnEdita_actionAdapter implements
        java.awt.event.ActionListener {
    FrameConsultaCliente adaptee;

    FrameConsultaCliente_btnEdita_actionAdapter(FrameConsultaCliente adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnEdita_actionPerformed(e);
    }
}

class FrameConsultaCliente_btnLimpar_actionAdapter implements
        java.awt.event.ActionListener {
    FrameConsultaCliente adaptee;

    FrameConsultaCliente_btnLimpar_actionAdapter(FrameConsultaCliente adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnLimpar_actionPerformed(e);
    }
}

class FrameConsultaCliente_btnRemover_actionAdapter implements
        java.awt.event.ActionListener {
    FrameConsultaCliente adaptee;

    FrameConsultaCliente_btnRemover_actionAdapter(FrameConsultaCliente
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnRemover_actionPerformed(e);
    }
}