package gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.JTable;
import javax.swing.table.*;

import fachada.Fachada;
import funcionario.Funcionario;
import util.DadosResidenciais;
import util.Iterator;
import gui.FrameCadastroFuncionario;

/**
 * <p>Title: FrameConsultaFuncionario</p>
 * <p>Description: Frame de Consulta de funcionrios </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Thiago Arajo
 * @version 1.0
 */

public class FrameConsultaFuncionario extends JFrame {
    JTextField edtTelefone = new JTextField();
    JTextField edtLogin = new JTextField();
    JTextField edtNome = new JTextField();
    JTextField edtBairro = new JTextField();
    JTextField edtCidade = new JTextField();
    JComboBox cmbCargo = new JComboBox();
    JPanel jPanel1 = new JPanel();
    Border border1;
    TitledBorder titledBorder1;
    JButton btnBuscar = new JButton();
    JButton btnLimpar = new JButton();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTable tblResult = new JTable();
    JLabel lblCargo = new JLabel();
    JLabel lblBairro = new JLabel();
    JLabel lblCidade = new JLabel();
    JLabel lblTelefone = new JLabel();
    JLabel lblLogin = new JLabel();
    JLabel lblNome = new JLabel();

    private Funcionario operador;
    private Fachada fachada;
    private String[] nomeColunas = {"Nome", "Login", "Telefone", "Cargo"};
    DefaultTableModel tbmResult;
    JButton edtEditar = new JButton();
    JButton edtRemover = new JButton();


    public FrameConsultaFuncionario(Fachada fachada, Funcionario operador) {
        try {
            jbInit();
            this.fachada = fachada;
            this.operador = operador;
            cmbCargo.addItem("Caixa");
            cmbCargo.addItem("Cozinheiro");
            cmbCargo.addItem("Entregador");
            cmbCargo.addItem("Gerente");
            cmbCargo.addItem("");
            cmbCargo.setSelectedIndex(Funcionario.CARGO_VAZIO);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
    public static void main(String[] args) {

    }
    private void jbInit() throws Exception {
        border1 = BorderFactory.createEtchedBorder(Color.white,new
            Color(148, 145, 140));
        titledBorder1 = new TitledBorder(border1,"Dados da Consulta");
        cmbCargo.setBounds(new Rectangle(59, 89, 195, 22));
        edtCidade.setBounds(new Rectangle(273, 58, 142, 21));
        edtBairro.setBounds(new Rectangle(59, 58, 140, 21));
        edtNome.setBounds(new Rectangle(59, 27, 210, 22));
        edtLogin.setBounds(new Rectangle(59, 120, 103, 22));
        edtTelefone.setBounds(new Rectangle(316, 27, 99, 22));
        edtTelefone.setToolTipText("");
        this.getContentPane().setLayout(null);
        jPanel1.setBorder(titledBorder1);
        jPanel1.setBounds(new Rectangle(12, 11, 428, 160));
        jPanel1.setLayout(null);
        btnBuscar.setBounds(new Rectangle(273, 120, 66, 23));
        btnBuscar.setMargin(new Insets(0, 0, 0, 0));
        btnBuscar.setText("Buscar");
        btnBuscar.addActionListener(new
            FrameConsultaFuncionario_btnBuscar_actionAdapter(this));
        btnLimpar.setBounds(new Rectangle(347, 120, 66, 23));
        btnLimpar.setMargin(new Insets(0, 0, 0, 0));
        btnLimpar.setText("Limpar");
        btnLimpar.addActionListener(new
            FrameConsultaFuncionario_btnLimpar_actionAdapter(this));
        jScrollPane1.setBounds(new Rectangle(13, 178, 425, 208));
        lblCargo.setText("Cargo:");
        lblCargo.setBounds(new Rectangle(12, 89, 49, 22));
        lblBairro.setText("Bairro:");
        lblBairro.setBounds(new Rectangle(9, 60, 41, 17));
        lblCidade.setText("Cidade:");
        lblCidade.setBounds(new Rectangle(220, 57, 48, 23));
        lblTelefone.setText("Tel:");
        lblTelefone.setBounds(new Rectangle(288, 28, 25, 21));
        lblLogin.setText("Login:");
        lblLogin.setBounds(new Rectangle(12, 121, 43, 21));
        lblNome.setText("Nome:");
        lblNome.setBounds(new Rectangle(12, 27, 44, 23));
        edtEditar.setBounds(new Rectangle(296, 391, 66, 23));
        edtEditar.setMargin(new Insets(0, 0, 0, 0));
        edtEditar.setText("Editar");
        edtEditar.addActionListener(new
            FrameConsultaFuncionario_edtEditar_actionAdapter(this));
        edtRemover.setBounds(new Rectangle(372, 391, 66, 23));
        edtRemover.setMargin(new Insets(0, 0, 0, 0));
        edtRemover.setText("Remover");
        edtRemover.addActionListener(new
            FrameConsultaFuncionario_edtRemover_actionAdapter(this));
        this.setResizable(false);
        this.setTitle("Consulta de Funcionrio");
        jPanel1.add(btnLimpar, null);
        jPanel1.add(btnBuscar, null);
        jPanel1.add(lblNome, null);
        jPanel1.add(edtNome, null);
        jPanel1.add(edtTelefone, null);
        jPanel1.add(lblTelefone, null);
        jPanel1.add(lblBairro, null);
        jPanel1.add(lblCargo, null);
        jPanel1.add(lblLogin, null);
        jPanel1.add(edtBairro, null);
        jPanel1.add(cmbCargo, null);
        jPanel1.add(edtLogin, null);
        jPanel1.add(edtCidade, null);
        jPanel1.add(lblCidade, null);
        this.getContentPane().add(edtRemover, null);
        this.getContentPane().add(edtEditar, null);
        this.getContentPane().add(jScrollPane1, null);
        jScrollPane1.getViewport().add(tblResult, null);
        this.getContentPane().add(jPanel1, null);
        int i;
        TableColumn tableColumn;

        tblResult.getTableHeader().setReorderingAllowed(false);
        tblResult.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tbmResult = new DefaultTableModel(nomeColunas, 0) {
            public boolean isCellEditable(int x, int y) { return false; } };

        tblResult.setModel(tbmResult);
        for (i = 0; i < 4; i++) {
            tableColumn = tblResult.getColumnModel().getColumn(i);
            switch (i) {
            case 0:
                tableColumn.setPreferredWidth(120);
                break;
            case 1:
                tableColumn.setPreferredWidth(40);
                break;
            case 2:
                tableColumn.setPreferredWidth(35);
                break;
            case 3:
                tableColumn.setPreferredWidth(35);
                break;
            default:

            }
        }


    }

    void btnBuscar_actionPerformed(ActionEvent e) {
        DadosResidenciais d = new DadosResidenciais();
        Funcionario f = new Funcionario();
        Funcionario w;
        Iterator iterador;
        int i=0;

        if (!edtNome.getText().equals("")) {
            f.setNome(edtNome.getText());
        }
        if (!edtTelefone.getText().equals("")) {
            f.getDadosResidenciais().setTelefone(edtTelefone.getText());
        }
        if (!edtBairro.getText().equals("")) {
            f.getDadosResidenciais().setBairro(edtBairro.getText());
        }
        if (!edtLogin.getText().equals("")) {
            f.setLogin(edtLogin.getText());
        }
        f.setCargo(cmbCargo.getSelectedIndex());
        try {
            iterador = fachada.like(operador,f).getIterator();
            while (iterador.hasNext()) {
                w = (Funcionario) iterador.next();
                tbmResult.setNumRows(i+1);
                tbmResult.setValueAt(w.getNome(), i, 0);
                tbmResult.setValueAt(w.getLogin(), i, 1);
                tbmResult.setValueAt(w.getDadosResidenciais().getTelefone(), i,
                    2);
                tbmResult.setValueAt(w.getCargoDescricao(), i, 3);
                i++;
            }
        } catch (IllegalArgumentException ex) {
            JOptionPane.showMessageDialog(this,ex.getMessage(),
                "Pizza Delivery", 0);
        }
    }

    void btnLimpar_actionPerformed(ActionEvent e) {
        edtNome.setText("");
        edtTelefone.setText("");
        edtBairro.setText("");
        edtCidade.setText("");
        cmbCargo.setSelectedIndex(Funcionario.CARGO_VAZIO);
        edtLogin.setText("");
    }

    void edtEditar_actionPerformed(ActionEvent e) {
        String login;
        int linha;
        Iterator it;
        Funcionario f = new Funcionario();
        FrameCadastroFuncionario frame;

        linha = tblResult.getSelectedRow();
        if (linha != -1) {
            login = (String) tblResult.getValueAt(linha, 1);
            f.setLogin(login);
            it = fachada.match(operador, f, Funcionario.MATCH_LOGIN).
                getIterator();
            if (it.hasNext()) {
                f = (Funcionario) it.next();
                frame = new FrameCadastroFuncionario(fachada, operador,
                    false, false);
                frame.setBounds(200,200,450,405);
                frame.edtBairro.setText(f.getDadosResidenciais().getBairro());
                frame.edtCidade.setText(f.getDadosResidenciais().getCidade());
                frame.edtConfirmacao.setText(f.getSenha());
                frame.edtEndereco.setText(f.getDadosResidenciais().
                    getEndereco());
                frame.edtLogin.setText(f.getLogin());
                frame.edtLogin.setEnabled(false);
                frame.edtNome.setText(f.getNome());
                frame.edtReferencia.setText(f.getDadosResidenciais().
                    getReferencia());
                frame.edtSalario.setText("" + f.getSalario());
                frame.edtSenha.setText(f.getSenha());
                frame.edtTelefone.setText(f.getDadosResidenciais().
                    getTelefone());
                frame.cmbCargo.setSelectedIndex(f.getCargo());
                if (f.getCargo() == Funcionario.GERENTE) {
                    frame.cmbCargo.setEnabled(false);
                }
                frame.show();
            }
        }
    }

    void edtRemover_actionPerformed(ActionEvent e) {
        String login;
        int linha;
        int confirm;
        Iterator it;
        Funcionario f = new Funcionario();
        FrameCadastroFuncionario frame;

        linha = tblResult.getSelectedRow();
        if (linha != -1) {
            confirm = JOptionPane.showConfirmDialog(this,
                "Deseja realmente excluir esse funcionario?","Pizza Delivery"
                , JOptionPane.OK_CANCEL_OPTION , JOptionPane.QUESTION_MESSAGE);
            if (confirm == JOptionPane.OK_OPTION) {
                login = (String) tblResult.getValueAt(linha, 1);
                f.setLogin(login);
                try {
                    fachada.remover(operador, f);
                    tbmResult.removeRow(linha);
                } catch (IllegalArgumentException ex) {
                    JOptionPane.showMessageDialog(this, ex.getMessage(),
                    "Pizza Delivery",0);
                }
            }
        }
    }
}

class FrameConsultaFuncionario_btnBuscar_actionAdapter implements java.awt.
        event.ActionListener {
    FrameConsultaFuncionario adaptee;

    FrameConsultaFuncionario_btnBuscar_actionAdapter(FrameConsultaFuncionario
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnBuscar_actionPerformed(e);
    }
}

class FrameConsultaFuncionario_btnLimpar_actionAdapter implements java.awt
        .event.ActionListener {
    FrameConsultaFuncionario adaptee;

    FrameConsultaFuncionario_btnLimpar_actionAdapter(FrameConsultaFuncionario
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnLimpar_actionPerformed(e);
    }
}

class FrameConsultaFuncionario_edtEditar_actionAdapter implements java.awt
        .event.ActionListener {
    FrameConsultaFuncionario adaptee;

    FrameConsultaFuncionario_edtEditar_actionAdapter(FrameConsultaFuncionario
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.edtEditar_actionPerformed(e);
    }
}

class FrameConsultaFuncionario_edtRemover_actionAdapter implements java.awt
        .event.ActionListener {
    FrameConsultaFuncionario adaptee;

    FrameConsultaFuncionario_edtRemover_actionAdapter(FrameConsultaFuncionario
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.edtRemover_actionPerformed(e);
    }
}