package gui;

import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.table.*;

import fachada.Fachada;
import funcionario.Funcionario;
import pedido.Pedido;
import pedido.RepositorioPedidos;
import util.Iterator;
import gui.FrameCadastroPedidos;

/**
 * <p>Title: FrameConsultarPedido</p>
 * <p>Description: Consulta um pedido</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: VipTeam</p>
 * @author Rafael Cavalcanti Ortolan
 * @version 1.0
 */

public class FrameConsultaPedidos extends JFrame {


    private Fachada fachada;
    private String[] nomesCol = {"Nmero", "Taxa Entrega", "Cliente",
                                 "Funcionrio","Produtos"};
    private DefaultTableModel modeloTabela;
    private Funcionario funcionario;

    JPanel jPanel1 = new JPanel();
    Border border1;
    TitledBorder titledBorder1;
    JTextField edtNomeFuncionario = new JTextField();
    JTextField edtNomeCliente = new JTextField();
    JButton btnConsultar = new JButton();
    JTextField edtTelefoneCliente = new JTextField();
    JTextField edtNumero = new JTextField();
    JCheckBox chbNumero = new JCheckBox();
    JCheckBox chbNomeCliente = new JCheckBox();
    JCheckBox chbNomeFuncionario = new JCheckBox();
    JCheckBox chbTelefoneCliente = new JCheckBox();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTable tblResultado = new JTable();
    JButton btnLimpar = new JButton();
    JButton btnFechar = new JButton();
    JButton btnRemover = new JButton();
    JButton btnEditar = new JButton();

    public FrameConsultaPedidos(Fachada f, Funcionario funcionario) {
        try {
            this.fachada = f;
            this.funcionario = funcionario;
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
    public static void main(String[] args) {
//        FrameConsultaPedidos frameConsultaPedidos1 = new FrameConsultaPedidos();
    }
    private void jbInit() throws Exception {
        border1 = BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
        this.setTitle("Consulta Pedido");
        this.setBounds(100,100,530,550);
        titledBorder1 = new TitledBorder(border1,"Consulta Pedido");
        jPanel1.setLayout(null);
        jPanel1.setBorder(titledBorder1);
        edtNomeFuncionario.setBounds(new Rectangle(170, 83, 216, 21));
        edtNomeCliente.setBounds(new Rectangle(170, 57, 216, 21));
        btnConsultar.setBounds(new Rectangle(406, 157, 91, 34));
        btnConsultar.setText("Consultar");
        btnConsultar.addActionListener(new FrameConsultaPedidos_btnConsultar_actionAdapter(this));
        edtTelefoneCliente.setBounds(new Rectangle(170, 110, 216, 21));
        edtNumero.setBounds(new Rectangle(170, 30, 216, 21));
        chbNumero.setText("Numero do Pedido:");
        chbNumero.setBounds(new Rectangle(17, 28, 134, 25));
        chbNomeCliente.setBounds(new Rectangle(17, 57, 134, 25));
        chbNomeCliente.setText("Nome do Cliente:");
        chbNomeFuncionario.setBounds(new Rectangle(17, 85, 149, 25));
        chbNomeFuncionario.setText("Nome do Funcionario:");
        chbTelefoneCliente.setBounds(new Rectangle(17, 115, 134, 25));
        chbTelefoneCliente.setText("Telefone do Cliente:");
        jScrollPane1.setBounds(new Rectangle(28, 208, 469, 256));
        btnLimpar.setBounds(new Rectangle(79, 157, 91, 34));
        btnLimpar.addActionListener(new FrameConsultaPedidos_btnLimpar_actionAdapter(this));
        btnLimpar.setText("Limpar");
        btnFechar.addActionListener(new FrameConsultaPedidos_btnFechar_actionAdapter(this));
        btnFechar.setText("Fechar");
        btnFechar.setBounds(new Rectangle(406, 476, 91, 34));
        btnRemover.addActionListener(new FrameConsultaPedidos_btnRemover_actionAdapter(this));
        btnRemover.setText("Remover");
        btnRemover.setBounds(new Rectangle(298, 157, 91, 34));
        btnEditar.setBounds(new Rectangle(189, 157, 91, 34));
        btnEditar.addActionListener(new FrameConsultaPedidos_btnEditar_actionAdapter(this));
        btnEditar.setText("Editar");
        this.getContentPane().add(jPanel1, BorderLayout.CENTER);
        jPanel1.add(chbNumero, null);
        jPanel1.add(chbNomeCliente, null);
        jPanel1.add(chbNomeFuncionario, null);
        jPanel1.add(chbTelefoneCliente, null);
        jPanel1.add(edtNomeFuncionario, null);
        jPanel1.add(edtNomeCliente, null);
        jPanel1.add(edtNumero, null);
        jPanel1.add(edtTelefoneCliente, null);
        jPanel1.add(jScrollPane1, null);
        jPanel1.add(btnConsultar, null);
        jPanel1.add(btnLimpar, null);
        jPanel1.add(btnFechar, null);
        jPanel1.add(btnRemover, null);
        jPanel1.add(btnEditar, null);
        jScrollPane1.getViewport().add(tblResultado, null);
        tblResultado.getTableHeader().setReorderingAllowed(false);
        modeloTabela = new DefaultTableModel(nomesCol,0) {
            public Class getColumnClass(int col) {
                if (col == 0) {
                    return Integer.class;
                } else if (col == 1) {
                    return Float.class;
                } else {
                    return String.class;
                }
            }
            public boolean isCellEditable(int x, int y) {
                return false;
            }
        };
        tblResultado.setModel(modeloTabela);
    }

    void btnConsultar_actionPerformed(ActionEvent e) {
        int criterios = 0;
        int i;
        Pedido p = new Pedido();
        Pedido pedido;
        RepositorioPedidos pedidos;
        Iterator iterador;

        try {
            if (chbNumero.isSelected()) {
                criterios = criterios | Pedido.MATCH_NUMERO;
                p.setNumero(Integer.parseInt(edtNumero.getText()));
            }
            if (chbNomeCliente.isSelected()) {
                criterios = criterios | Pedido.MATCH_NOME_CLIENTE;
                p.getCliente().setNome(edtNomeCliente.getText());
            }
            if (chbNomeFuncionario.isSelected()) {
                criterios = criterios | Pedido.MATCH_NOME_FUNCIONARIO;
                p.getFuncionario().setNome(edtNomeFuncionario.getText());
            }
            if (chbTelefoneCliente.isSelected()) {
                criterios = criterios | Pedido.MATCH_TELEFONE_CLIENTE;
                p.getCliente().getDadosResidenciais().setTelefone(edtTelefoneCliente.getText());
            }
            pedidos = this.fachada.match(funcionario,p,criterios);
            iterador = pedidos.getIterator();
            this.modeloTabela.setRowCount(0);
            i = 0;
            while (iterador.hasNext()) {
                modeloTabela.setRowCount(i+1);
                pedido = (Pedido) iterador.next();
                tblResultado.setValueAt(new Integer(pedido.getNumero()), i, 0);
                tblResultado.setValueAt(new Float(pedido.getTaxaEntrega()), i, 1);
                tblResultado.setValueAt(pedido.getCliente().toString(), i, 2);
                tblResultado.setValueAt(pedido.getFuncionario().getNome(), i, 3);
                tblResultado.setValueAt(pedido.getProdutos().toString(),i, 4);
                i++;
            }
        } catch (IllegalArgumentException ex) {
            JOptionPane.showMessageDialog(this,ex.getMessage(),
                "Falha na Consulta",JOptionPane.ERROR_MESSAGE);
        }
    }

    void btnLimpar_actionPerformed(ActionEvent e) {
        limparDados();
    }

    void limparDados () {
        modeloTabela.setRowCount(0);
        chbNumero.setSelected(false);
        chbNomeCliente.setSelected(false);
        chbNomeFuncionario.setSelected(false);
        chbTelefoneCliente.setSelected(false);
        edtNumero.setText("");
        edtNomeCliente.setText("");
        edtNomeFuncionario.setText("");
        edtTelefoneCliente.setText("");
    }

    void btnFechar_actionPerformed(ActionEvent e) {
        this.dispose();
    }

    void btnRemover_actionPerformed(ActionEvent e) {
        if (tblResultado.getSelectedRow() < 0) {
            JOptionPane.showMessageDialog(this,"Selecione alguma linha para Editar",
                "Falha na Remoo",JOptionPane.ERROR_MESSAGE);
        } else {
            Pedido p = new Pedido();
            Pedido pedido;
            Iterator iterador;

            try {
                p.setNumero(((Integer) tblResultado.getValueAt(tblResultado.getSelectedRow(),0)).intValue());
                iterador = (fachada.match(this.funcionario, p, Pedido.MATCH_NUMERO)).getIterator();
                pedido = (Pedido) iterador.next();
                fachada.remover(funcionario, pedido);
                modeloTabela.removeRow(tblResultado.getSelectedRow());
            } catch (IllegalArgumentException ex) {
                JOptionPane.showMessageDialog(this,ex.getMessage(),
                    "Falha na Remoo",JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    void btnEditar_actionPerformed(ActionEvent e) {
        if (tblResultado.getSelectedRow() < 0) {
            JOptionPane.showMessageDialog(this,"Selecione alguma linha para Editar",
                "Falha na Edio",JOptionPane.ERROR_MESSAGE);
        }
        else {
            Pedido p = new Pedido();
            Pedido pedido;
            Iterator iterador;

            p.setNumero(((Integer) tblResultado.getValueAt(tblResultado.getSelectedRow(),0)).intValue());
            iterador = (fachada.match(this.funcionario, p, Pedido.MATCH_NUMERO)).getIterator();
            pedido = (Pedido) iterador.next();
            FrameCadastroPedidos edita = new FrameCadastroPedidos(this.fachada, this.funcionario, pedido);
            edita.show();
        }
    }
}

class FrameConsultaPedidos_btnConsultar_actionAdapter implements java.awt.event.ActionListener {
    FrameConsultaPedidos adaptee;

    FrameConsultaPedidos_btnConsultar_actionAdapter(FrameConsultaPedidos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnConsultar_actionPerformed(e);
    }
}

class FrameConsultaPedidos_btnLimpar_actionAdapter implements java.awt.event.ActionListener {
    FrameConsultaPedidos adaptee;

    FrameConsultaPedidos_btnLimpar_actionAdapter(FrameConsultaPedidos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnLimpar_actionPerformed(e);
    }
}

class FrameConsultaPedidos_btnFechar_actionAdapter implements java.awt.event.ActionListener {
    FrameConsultaPedidos adaptee;

    FrameConsultaPedidos_btnFechar_actionAdapter(FrameConsultaPedidos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnFechar_actionPerformed(e);
    }
}

class FrameConsultaPedidos_btnRemover_actionAdapter implements java.awt.event.ActionListener {
    FrameConsultaPedidos adaptee;

    FrameConsultaPedidos_btnRemover_actionAdapter(FrameConsultaPedidos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnRemover_actionPerformed(e);
    }
}

class FrameConsultaPedidos_btnEditar_actionAdapter implements java.awt.event.ActionListener {
    FrameConsultaPedidos adaptee;

    FrameConsultaPedidos_btnEditar_actionAdapter(FrameConsultaPedidos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnEditar_actionPerformed(e);
    }
}