package gui;


import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.JTable;
import javax.swing.table.*;

import fachada.Fachada;
import funcionario.Funcionario;
import produto.Produto;
import produto.RepositorioProdutos;
import util.Iterator;
import exception.PermissaoNegadaException;
import exception.ProdutoNaoCadastradoException;

/**
 * <p>Title: FrameConsultaProdutos</p>
 * <p>Description: Tela de Consulta/Controle de Produtos</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Mayerber Carvalho Neto
 * @version 1.0
 */

public class FrameConsultaProdutos extends JFrame {


    private Fachada fachada;
    private Funcionario operador;
    private String[] nomeColunas = {"Nome", "Tamanho", "Preo (R$)",
                                     "Descrio"};

    JPanel jPanel1 = new JPanel();
    Border border1;
    TitledBorder titledBorder1;
    JCheckBox chbNome = new JCheckBox();
    JCheckBox chbTamanho = new JCheckBox();
    JCheckBox chbPreco = new JCheckBox();
    JCheckBox chbDescricao = new JCheckBox();
    JTextField edtNome = new JTextField();
    JComboBox cmbTamanho = new JComboBox();
    JTextField edtPreco = new JTextField();
    JTextField edtDescricao = new JTextField();
    JButton btnConsultar = new JButton();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTable tblResultado = new JTable();
    JButton btnFechar = new JButton();
    JButton btnRemover = new JButton();
    DefaultTableModel tbmResultado;
    JButton btnAtualizar = new JButton();
    JButton btnLimpar = new JButton();


    public FrameConsultaProdutos(Fachada fachada, Funcionario operador) {
        this.fachada = fachada;
        this.operador = operador;

        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        int i;

        border1 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
        titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Produto");
        this.setBounds(0,0,440,390);
        this.getContentPane().setLayout(null);
        this.setTitle("Consulta de Produtos");
        this.setResizable(false);
        jPanel1.setForeground(new Color(102, 102, 153));
        jPanel1.setBorder(titledBorder1);
        jPanel1.setBounds(new Rectangle(2, 3, 422, 353));
        jPanel1.setLayout(null);
        chbNome.setForeground(new Color(102, 102, 153));
        chbNome.setText("Nome:");
        chbNome.setBounds(new Rectangle(14, 21, 62, 24));
        chbTamanho.setBounds(new Rectangle(14, 52, 82, 24));
        chbTamanho.setText("Tamanho:");
        chbTamanho.setForeground(new Color(102, 102, 153));
        chbPreco.setBounds(new Rectangle(14, 84, 84, 24));
        chbPreco.setText("Preo (R$):");
        chbPreco.setForeground(new Color(102, 102, 153));
        chbDescricao.setBounds(new Rectangle(14, 116, 85, 24));
        chbDescricao.setText("Descrio:");
        chbDescricao.setForeground(new Color(102, 102, 153));
        edtNome.setBounds(new Rectangle(107, 23, 305, 21));
        edtPreco.setBounds(new Rectangle(107, 86, 305, 21));
        edtDescricao.setBounds(new Rectangle(107, 118, 305, 21));
        cmbTamanho.setBounds(new Rectangle(107, 54, 305, 21));
        btnConsultar.setBounds(new Rectangle(99, 152, 93, 27));
        btnConsultar.setText("Consultar");
        btnConsultar.addActionListener(new FrameConsultaProdutos_btnConsultar_actionAdapter(this));
        jScrollPane1.setBounds(new Rectangle(15, 198, 397, 109));
        btnFechar.setBounds(new Rectangle(319, 152, 93, 27));
        btnFechar.setText("Fechar");
        btnFechar.addActionListener(new FrameConsultaProdutos_btnFechar_actionAdapter(this));
        btnRemover.setBounds(new Rectangle(319, 312, 93, 27));
        btnRemover.setText("Remover");
        btnRemover.addActionListener(new FrameConsultaProdutos_btnRemover_actionAdapter(this));
        btnAtualizar.setBounds(new Rectangle(210, 312, 93, 27));
        btnAtualizar.setText("Atualizar");
        btnAtualizar.addActionListener(new FrameConsultaProdutos_btnAtualizar_actionAdapter(this));
        btnLimpar.setBounds(new Rectangle(210, 152, 93, 27));
        btnLimpar.setText("Limpar");
        btnLimpar.addActionListener(new FrameConsultaProdutos_btnLimpar_actionAdapter(this));
        jPanel1.add(edtNome, null);
        jPanel1.add(cmbTamanho, null);
        jPanel1.add(chbTamanho, null);
        jPanel1.add(chbNome, null);
        jPanel1.add(edtPreco, null);
        jPanel1.add(chbDescricao, null);
        jPanel1.add(chbPreco, null);
        jPanel1.add(edtDescricao, null);
        jPanel1.add(jScrollPane1, null);
        jPanel1.add(btnFechar, null);
        jPanel1.add(btnRemover, null);
        jPanel1.add(btnAtualizar, null);
        jPanel1.add(btnLimpar, null);
        jPanel1.add(btnConsultar, null);
        jScrollPane1.getViewport().add(tblResultado, null);
        this.getContentPane().add(jPanel1, null);
        cmbTamanho.addItem(Produto.descricaoTamanho[0]);
        cmbTamanho.addItem(Produto.descricaoTamanho[1]);
        cmbTamanho.addItem(Produto.descricaoTamanho[2]);
        cmbTamanho.addItem(Produto.descricaoTamanho[3]);
        cmbTamanho.addItem(Produto.descricaoTamanho[4]);
        tblResultado.getTableHeader().setReorderingAllowed(false);
        tblResultado.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tbmResultado = new DefaultTableModel(nomeColunas, 0) {
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                boolean ret;

                if (columnIndex == 0 || columnIndex == 1) {
                    ret = false;
                } else {
                    ret = true;
                }

                return ret;
            }

            public Class getColumnClass(int c) {
                Class ret;

                if (c == 0 || c == 1 || c == 3) {
                    ret = String.class;
                } else {
                    ret = Float.class;
                }

                return ret;
            }

        };

        tblResultado.setModel(tbmResultado);
        tblResultado.getColumnModel().getColumn(0).setPreferredWidth(80);
        tblResultado.getColumnModel().getColumn(1).setPreferredWidth(35);
        tblResultado.getColumnModel().getColumn(2).setPreferredWidth(40);
        tblResultado.getColumnModel().getColumn(3).setPreferredWidth(100);
    }

    void btnConsultar_actionPerformed(ActionEvent e) {
        String nome = edtNome.getText();
        int tamanho = cmbTamanho.getSelectedIndex();
        String preco = edtPreco.getText();
        String desc = edtDescricao.getText();
        int criterios = 0;
        Produto prod = new Produto();
        RepositorioProdutos repProdutos;
        Iterator iterador;
        Object[] linha;

        try {
            if (chbNome.isSelected()) {
                criterios = criterios | Produto.MATCH_NOME;
                prod.setNome(nome);
            }

            if (chbTamanho.isSelected()) {
                criterios = criterios | Produto.MATCH_TAMANHO;
                prod.setTamanho(tamanho);
            }

            if (chbPreco.isSelected()) {
                Float precofloat = new Float(preco);

                criterios = criterios | Produto.MATCH_PRECO;
                prod.setPreco(precofloat.floatValue());
            }

            if (chbDescricao.isSelected()) {
                criterios = criterios | Produto.MATCH_DESCRICAO;
                prod.setDescricao(desc);
            }

            repProdutos = this.fachada.match(this.operador, prod, criterios);
            iterador = repProdutos.getIterator();

            tbmResultado.setRowCount(0);
            while (iterador.hasNext()) {
                prod = ((Produto) iterador.next());

                linha = new Object[4];
                linha[0] = prod.getNome();
                linha[1] = Produto.descricaoTamanho[prod.getTamanho()];
                linha[2] = new Float(prod.getPreco());
                linha[3] = prod.getDescricao();
                tbmResultado.addRow(linha);
            }
        } catch (NumberFormatException ex) {
            JOptionPane.showMessageDialog(this, "Preo invlido.",
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
        } catch (IllegalArgumentException ex) {
            JOptionPane.showMessageDialog(this, ex.getMessage(),
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
        }
    }

    void btnFechar_actionPerformed(ActionEvent e) {
        this.dispose();
    }

    void btnRemover_actionPerformed(ActionEvent e) {
        int selRow = tblResultado.getSelectedRow();
        Produto prod = new Produto();

        if (selRow == -1) {
            JOptionPane.showMessageDialog(this, "Selecione um produto.",
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
        } else if (tblResultado.isEditing()) {
            JOptionPane.showMessageDialog(this, "Termine de alterar a clula.",
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
        } else {
            try {
                prod.setNome((String) tbmResultado.getValueAt(selRow, 0));
                prod.setTamanho(getTamanhoPelaDescricao((String) tbmResultado.getValueAt(selRow, 1)));
                this.fachada.remover(this.operador, prod);
                tbmResultado.removeRow(selRow);
                JOptionPane.showMessageDialog(this, "Produto removido.",
                                                this.getTitle(),
                                                JOptionPane.INFORMATION_MESSAGE);
            } catch (PermissaoNegadaException ex) {
                JOptionPane.showMessageDialog(this, ex.getMessage(),
                                                this.getTitle(),
                                                JOptionPane.ERROR_MESSAGE);
            } catch (ProdutoNaoCadastradoException ex) {
                JOptionPane.showMessageDialog(this, ex.getMessage(),
                                                this.getTitle(),
                                                JOptionPane.ERROR_MESSAGE);
            } catch (IllegalArgumentException ex) {
                JOptionPane.showMessageDialog(this, ex.getMessage(),
                                                this.getTitle(),
                                                JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    private int getTamanhoPelaDescricao(String descricaoTamanho) {
        int ret;

        for (ret = 0; ret < Produto.descricaoTamanho.length; ret++) {
            if (Produto.descricaoTamanho[ret].equals(descricaoTamanho)) {
                break;
            }
        }

        return ret;
    }

    void btnLimpar_actionPerformed(ActionEvent e) {
        edtNome.setText("");
        cmbTamanho.setSelectedIndex(0);
        edtPreco.setText("");
        edtDescricao.setText("");
    }

    void btnAtualizar_actionPerformed(ActionEvent e) {
        int selRow = tblResultado.getSelectedRow();
        Produto prod = new Produto();
        Float tmp;

        if (selRow == -1) {
            JOptionPane.showMessageDialog(this, "Selecione um produto.",
                                        this.getTitle(),
                                        JOptionPane.ERROR_MESSAGE);
        } else if (tblResultado.isEditing()) {
            JOptionPane.showMessageDialog(this, "Termine de alterar a clula.",
                                        this.getTitle(),
                                        JOptionPane.ERROR_MESSAGE);
        } else {
            try {
                prod.setNome((String) tbmResultado.getValueAt(selRow, 0));
                prod.setTamanho(getTamanhoPelaDescricao((String) tbmResultado.getValueAt(selRow, 1)));
                tmp = (Float) tbmResultado.getValueAt(selRow, 2);
                prod.setPreco(tmp.floatValue());
                prod.setDescricao((String) tbmResultado.getValueAt(selRow, 3));
                this.fachada.atualizar(this.operador, prod);
                JOptionPane.showMessageDialog(this, "Produto atualizado.",
                                            this.getTitle(),
                                            JOptionPane.INFORMATION_MESSAGE);
            } catch (NullPointerException ex) {
                JOptionPane.showMessageDialog(this, "Preo invlido.",
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
            } catch (PermissaoNegadaException ex) {
                JOptionPane.showMessageDialog(this, ex.getMessage(),
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
            } catch (IllegalArgumentException ex) {
                JOptionPane.showMessageDialog(this, ex.getMessage(),
                                            this.getTitle(),
                                            JOptionPane.ERROR_MESSAGE);
            }
        }
    }
}

class FrameConsultaProdutos_btnConsultar_actionAdapter implements java.awt.event.ActionListener {
    FrameConsultaProdutos adaptee;

    FrameConsultaProdutos_btnConsultar_actionAdapter(FrameConsultaProdutos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnConsultar_actionPerformed(e);
    }
}

class FrameConsultaProdutos_btnFechar_actionAdapter implements java.awt.event.ActionListener {
    FrameConsultaProdutos adaptee;

    FrameConsultaProdutos_btnFechar_actionAdapter(FrameConsultaProdutos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnFechar_actionPerformed(e);
    }
}

class FrameConsultaProdutos_btnRemover_actionAdapter implements java.awt.event.ActionListener {
    FrameConsultaProdutos adaptee;

    FrameConsultaProdutos_btnRemover_actionAdapter(FrameConsultaProdutos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnRemover_actionPerformed(e);
    }
}

class FrameConsultaProdutos_btnLimpar_actionAdapter implements java.awt.event.ActionListener {
    FrameConsultaProdutos adaptee;

    FrameConsultaProdutos_btnLimpar_actionAdapter(FrameConsultaProdutos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnLimpar_actionPerformed(e);
    }
}

class FrameConsultaProdutos_btnAtualizar_actionAdapter implements java.awt.event.ActionListener {
    FrameConsultaProdutos adaptee;

    FrameConsultaProdutos_btnAtualizar_actionAdapter(FrameConsultaProdutos adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnAtualizar_actionPerformed(e);
    }
}
