package gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import funcionario.Funcionario;
import fachada.Fachada;


/**
 * <p>Title: FrameLogin</p>
 * <p>Description: Frame de login do sistema</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: VIP Team</p>
 * @author Thiago Arajo
 * @version 1.0
 */

public class FrameLogin extends JFrame {
  JButton btnCancelar = new JButton();
  JLabel lblLogin = new JLabel();
  JButton btnOk = new JButton();
  JLabel lblSenha = new JLabel();
  JTextField edtLogin = new JTextField();
  JPasswordField edtSenha = new JPasswordField();

  FramePrincipal retorno;
  Fachada fachada;

  public FrameLogin(Fachada fachada, FramePrincipal retorno) {
    try {
      jbInit();
      this.retorno = retorno;
      this.fachada = fachada;
    }
    catch(Exception e) {
      e.printStackTrace();
    }

  }
  public static void main(String[] args) {
//    FrameLogin frameLogin1 = new FrameLogin();
  }
  private void jbInit() throws Exception {
    btnCancelar.setBounds(new Rectangle(97, 79, 64, 27));
    btnCancelar.setMargin(new Insets(0, 0, 0, 0));
    btnCancelar.setText("Cancelar");
        btnCancelar.addActionListener(new FrameLogin_btnCancelar_actionAdapter
            (this));
    this.getContentPane().setLayout(null);
    lblLogin.setText("Login:");
    lblLogin.setBounds(new Rectangle(17, 20, 41, 17));
    btnOk.setBounds(new Rectangle(17, 79, 64, 27));
    btnOk.setText("OK");
    btnOk.addActionListener(new FrameLogin_btnOk_actionAdapter(this));
    lblSenha.setText("Senha:");
    lblSenha.setBounds(new Rectangle(17, 50, 41, 17));
    edtLogin.setText("bebosim");
    edtLogin.setBounds(new Rectangle(66, 18, 96, 20));
    edtSenha.setText("testedesenha");
    edtSenha.setBounds(new Rectangle(66, 48, 96, 20));
    this.setTitle("Login");
    this.getContentPane().add(lblLogin, null);
    this.getContentPane().add(lblSenha, null);
    this.getContentPane().add(edtLogin, null);
    this.getContentPane().add(edtSenha, null);
    this.getContentPane().add(btnOk, null);
    this.getContentPane().add(btnCancelar, null);
  }

    void btnOk_actionPerformed(ActionEvent e) {
        Funcionario operador;

        try {
            operador = fachada.login(edtLogin.getText(),
                new String(edtSenha.getPassword()));
            retorno.setOperador(operador);
            retorno.setTitle("Pizza Delivery  -  Operador: " + operador.
                getLogin());
            this.dispose();
        } catch (IllegalArgumentException ex) {
            JOptionPane.showMessageDialog(this, ex.getMessage(),
                "Pizza Delivery",JOptionPane.ERROR_MESSAGE);
        }
    }

    void btnCancelar_actionPerformed(ActionEvent e) {
        this.dispose();
    }
}

class FrameLogin_btnOk_actionAdapter implements java.awt.event.ActionListener {
    FrameLogin adaptee;

    FrameLogin_btnOk_actionAdapter(FrameLogin adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnOk_actionPerformed(e);
    }
}

class FrameLogin_btnCancelar_actionAdapter implements java.awt.event
        .ActionListener {
    FrameLogin adaptee;

    FrameLogin_btnCancelar_actionAdapter(FrameLogin adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.btnCancelar_actionPerformed(e);
    }
}