package gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import fachada.Fachada;
import funcionario.Funcionario;
import exception.RepositorioFuncionariosVazioException;

/**
 * <p>Title: Frame Principal</p>
 * <p>Description: Frame Principal do Sitema</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: VIP Team</p>
 * @author: Thiago Arajo
 * @version 1.0
 */

public class FramePrincipal extends JFrame {
    JMenuBar jMenuBar1 = new JMenuBar();
    JMenu mnuSessao = new JMenu();
    JMenu mnuArquivo = new JMenu();
    JMenu jMenu3 = new JMenu();
    JMenuItem mnuLogin = new JMenuItem();
    JMenuItem mnuLogout = new JMenuItem();
    JMenuItem mnuSair = new JMenuItem();
    JMenu mnuFuncionario = new JMenu();
    JMenuItem mnuFuncionarioNovo = new JMenuItem();
    JMenuItem mnuFuncionarioConsultar = new JMenuItem();
    JMenu mnuProdutos = new JMenu();
    JMenuItem mnuProdutosNovo = new JMenuItem();
    JMenuItem mnuProdutosConsultar = new JMenuItem();
    JMenu mnuClientes = new JMenu();
    JMenuItem mnuClientesNovo = new JMenuItem();
    JMenuItem mnuClientesConsultar = new JMenuItem();
    JMenu mnuPedidos = new JMenu();
    JMenuItem mnuPedidosNovo = new JMenuItem();
    JMenuItem mnuPedidosConsultar = new JMenuItem();
    JMenuItem jMenuItem12 = new JMenuItem();
    private Fachada fachada;
    private Funcionario operador;

    public FramePrincipal() {
        addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
            System.exit(0);
            }
        });
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        fachada = new Fachada();
        operador = null;
    }
    public Funcionario getOperador() {
        return operador;
    }
    public void setOperador(Funcionario funcionario) {
        this.operador = funcionario;
    }
    public static void main(String[] args) {
        FramePrincipal framePrincipal = new FramePrincipal();
        framePrincipal.setBounds(200,200,400,400);
        framePrincipal.show();
    }
    private void jbInit() throws Exception {
        this.getContentPane().setLayout(null);
        mnuSessao.setMnemonic('S');
        mnuSessao.setText("Sesso");
        mnuSessao.addActionListener(new FramePrincipal_mnuSessao_actionAdapter
            (this));
        mnuArquivo.setMnemonic('A');
        mnuArquivo.setText("Arquivo");
        jMenu3.setMnemonic('U');
        jMenu3.setText("Ajuda");
        mnuLogin.setText("Login");
        mnuLogin.addActionListener(new FramePrincipal_mnuLogin_actionAdapter
            (this));
        mnuLogout.setText("Logout");
        mnuLogout.addActionListener(new FramePrincipal_mnuLogout_actionAdapter
            (this));
        mnuSair.setText("Sair");
        mnuSair.addActionListener(new FramePrincipal_mnuSair_actionAdapter
            (this));
        mnuFuncionario.setText("Funcionrios");
        mnuFuncionarioNovo.setText("Novo");
        mnuFuncionarioNovo.addActionListener(new
            FramePrincipal_mnuFuncionarioNovo_actionAdapter(this));
        mnuFuncionarioConsultar.setText("Consultar");
        mnuFuncionarioConsultar.addActionListener(new
            FramePrincipal_mnuFuncionarioConsultar_actionAdapter(this));
        mnuProdutos.setText("Produtos");
        mnuProdutosNovo.setText("Novo");
        mnuProdutosNovo.addActionListener(new
            FramePrincipal_mnuProdutosNovo_actionAdapter(this));
        mnuProdutosConsultar.setText("Consultar");
        mnuProdutosConsultar.addActionListener(new
            FramePrincipal_mnuProdutosConsultar_actionAdapter(this));
        mnuClientes.setText("Clientes");
        mnuClientesNovo.setText("Novo");
        mnuClientesNovo.addActionListener(new
            FramePrincipal_mnuClientesNovo_actionAdapter(this));
        mnuClientesConsultar.setText("Consultar");
        mnuClientesConsultar.addActionListener(new
            FramePrincipal_mnuClientesConsultar_actionAdapter(this));
        mnuPedidos.setText("Pedidos");
        mnuPedidosNovo.setText("Novo");
        mnuPedidosNovo.addActionListener(new
            FramePrincipal_mnuPedidosNovo_actionAdapter(this));
        mnuPedidosConsultar.setText("Pedidos Pendentes");
        mnuPedidosConsultar.addActionListener(new
            FramePrincipal_mnuPedidosConsultar_actionAdapter(this));
        jMenuItem12.setText("Sobre");
        jMenuItem12.addActionListener(new
            FramePrincipal_jMenuItem12_actionAdapter(this));
        this.setJMenuBar(jMenuBar1);
        this.setTitle("PizzaDelivery Control System");
        jMenuBar1.add(mnuSessao);
        jMenuBar1.add(mnuArquivo);
        jMenuBar1.add(jMenu3);
        mnuSessao.add(mnuLogin);
        mnuSessao.add(mnuLogout);
        mnuSessao.addSeparator();
        mnuSessao.add(mnuSair);
        mnuArquivo.add(mnuFuncionario);
        mnuArquivo.add(mnuProdutos);
        mnuArquivo.add(mnuClientes);
        mnuArquivo.addSeparator();
        mnuArquivo.add(mnuPedidos);
        mnuFuncionario.add(mnuFuncionarioNovo);
        mnuFuncionario.add(mnuFuncionarioConsultar);
        mnuProdutos.add(mnuProdutosNovo);
        mnuProdutos.add(mnuProdutosConsultar);
        mnuClientes.add(mnuClientesNovo);
        mnuClientes.add(mnuClientesConsultar);
        mnuPedidos.add(mnuPedidosNovo);
        mnuPedidos.add(mnuPedidosConsultar);
        jMenu3.add(jMenuItem12);
    }
    void mnuLogin_actionPerformed(ActionEvent e) {
        try {
            fachada.touchFuncionario();
            // chama login
            FrameLogin fl = new FrameLogin(fachada, this);
            fl.setBounds(200,200,200,160);
            fl.show();
        } catch (RepositorioFuncionariosVazioException ex) {
            // criar funcionario inicial
            JOptionPane.showMessageDialog(this,ex.getMessage(),
                "Pizza Delivery", 0);
            FrameCadastroFuncionario fcf = new FrameCadastroFuncionario(fachada,
                operador, true, true);
            fcf.setBounds(200,200,450,405);
            fcf.cmbCargo.setSelectedIndex(Funcionario.GERENTE);
            fcf.cmbCargo.setEnabled(false);
            fcf.show();
        }
    }
    void mnuLogout_actionPerformed(ActionEvent e) {
        int confirm;

        confirm = JOptionPane.showConfirmDialog(this,"Efetuar Logout?",
            "Pizza Delivery",JOptionPane.OK_CANCEL_OPTION,
            JOptionPane.QUESTION_MESSAGE);
        if (confirm == JOptionPane.OK_OPTION) {
            this.operador = null;
            this.setTitle("Pizza Delivery");
        }
    }
    void mnuSair_actionPerformed(ActionEvent e) {
        System.exit(0);
    }
    void mnuSessao_actionPerformed(ActionEvent e) {
        // nao esta funcionando!!!
    }
    void mnuFuncionarioNovo_actionPerformed(ActionEvent e) {
        FrameCadastroFuncionario f = new FrameCadastroFuncionario(
                fachada, operador, true, false);
        f.setBounds(200,200,450,405);
        f.show();
    }
    void mnuFuncionarioConsultar_actionPerformed(ActionEvent e) {
        FrameConsultaFuncionario f = new FrameConsultaFuncionario(
                fachada, operador);
        f.setBounds(200,200,450,450);
        f.show();
    }
    void mnuProdutosNovo_actionPerformed(ActionEvent e) {
        FrameCadastroProdutos ap = new FrameCadastroProdutos(fachada, operador);
        ap.show();
    }
    void mnuProdutosConsultar_actionPerformed(ActionEvent e) {
        FrameConsultaProdutos cp = new FrameConsultaProdutos(fachada,operador);
        cp.show();
    }
    void mnuClientesNovo_actionPerformed(ActionEvent e) {
        FrameCadastroCliente cli = new FrameCadastroCliente(fachada,operador);
        cli.show();
    }
   void mnuClientesConsultar_actionPerformed(ActionEvent e) {
        FrameConsultaCliente cli = new FrameConsultaCliente(fachada,operador);
        cli.show();
    }
    void mnuPedidosNovo_actionPerformed(ActionEvent e) {
        FrameCadastroPedidos ep = new FrameCadastroPedidos(fachada,operador);
        ep.show();
    }
    void mnuPedidosConsultar_actionPerformed(ActionEvent e) {
        FrameConsultaPedidos cped = new FrameConsultaPedidos(fachada,operador);
        cped.show();
    }
    void jMenuItem12_actionPerformed(ActionEvent e) {
        String about = new String("Pizza Delivery Control System v1.0 \n\n" +
                                  "Autores:\n" +
                                  "  Mayerber Carvalho Neto\n" +
                                  "  Rafael Cavalcanti Ortolan\n" +
                                  "  Thiago Teixeira de Arajo\n\n" );
        if (operador != null) {
            about = about + "Operador logado no momento: " +
                operador.getLogin();
        }
        JOptionPane.showMessageDialog(this,about,"Pizza Delivery",
            JOptionPane.INFORMATION_MESSAGE);
    }
}
class FramePrincipal_mnuLogin_actionAdapter implements java.awt.event
        .ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_mnuLogin_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuLogin_actionPerformed(e);
    }
}
class FramePrincipal_mnuLogout_actionAdapter implements java.awt.event
        .ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_mnuLogout_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuLogout_actionPerformed(e);
    }
}
class FramePrincipal_mnuSair_actionAdapter implements java.awt.event
        .ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_mnuSair_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuSair_actionPerformed(e);
    }
}
class FramePrincipal_mnuSessao_actionAdapter implements java.awt.event
        .ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_mnuSessao_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuSessao_actionPerformed(e);
    }
}

class FramePrincipal_mnuFuncionarioNovo_actionAdapter implements java.awt.
        event.ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_mnuFuncionarioNovo_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuFuncionarioNovo_actionPerformed(e);
    }
}

class FramePrincipal_mnuFuncionarioConsultar_actionAdapter implements java.awt
        .event.ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_mnuFuncionarioConsultar_actionAdapter(FramePrincipal
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuFuncionarioConsultar_actionPerformed(e);
    }
}

class FramePrincipal_mnuProdutosNovo_actionAdapter implements java.awt.event
        .ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_mnuProdutosNovo_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuProdutosNovo_actionPerformed(e);
    }
}

class FramePrincipal_mnuProdutosConsultar_actionAdapter implements java.awt.
        event.ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_mnuProdutosConsultar_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuProdutosConsultar_actionPerformed(e);
    }
}

class FramePrincipal_mnuClientesNovo_actionAdapter implements java.awt.event
        .ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_mnuClientesNovo_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuClientesNovo_actionPerformed(e);
    }
}

class FramePrincipal_mnuClientesConsultar_actionAdapter implements java.awt
        .event.ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_mnuClientesConsultar_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuClientesConsultar_actionPerformed(e);
    }
}

class FramePrincipal_mnuPedidosNovo_actionAdapter implements java.awt.event
        .ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_mnuPedidosNovo_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuPedidosNovo_actionPerformed(e);
    }
}

class FramePrincipal_mnuPedidosConsultar_actionAdapter implements java.awt.
        event.ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_mnuPedidosConsultar_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuPedidosConsultar_actionPerformed(e);
    }
}

class FramePrincipal_jMenuItem12_actionAdapter implements java.awt.event
        .ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_jMenuItem12_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jMenuItem12_actionPerformed(e);
    }
}