package teste;

import fachada.Fachada;
import cliente.Cliente;
import cliente.CadastroClientes;
import funcionario.Funcionario;
import funcionario.CadastroFuncionarios;
import produto.Produto;
import produto.CadastroProdutos;
import produto.RepositorioProdutos;
import produto.RepositorioProdutosLista;
import pedido.Pedido;
import pedido.CadastroPedidos;
import util.DadosResidenciais;

/**
 * Title: Classe Teste
 * Description: testa o sistema.
 * Copyright: Copyright (c) 2002
 * Company: VIP Team
 * @author VIP Team
 * @version 1.0
 */

public class Teste {


    private Fachada fachada;

    public Teste() {
        this.fachada = new Fachada();

    }
    public static void main(String[] args) {
        Teste teste = new Teste();

        DadosResidenciais dados1 = new DadosResidenciais("endereco1",
                                                        "telefone1",
                                                        "bairro1",
                                                        "referencia1",
                                                        "cidade1");
        DadosResidenciais dados2 = new DadosResidenciais("endereco2",
                                                        "telefone2",
                                                        "bairro2",
                                                        "referencia2",
                                                        "cidade2");
        DadosResidenciais dados3 = new DadosResidenciais("endereco3",
                                                        "telefone2",
                                                        "bairro3",
                                                        "referencia3",
                                                        "cidade3");
        DadosResidenciais dados4 = new DadosResidenciais("endereco4",
                                                        "telefone4",
                                                        "bairro4",
                                                        "referencia4",
                                                        "cidade4");
        RepositorioProdutos rep1 = new RepositorioProdutosLista();
        Cliente c1 = new Cliente("rafael",dados1);
        Cliente c2 = new Cliente("thiago",dados2);
        Cliente c3 = new Cliente("neto",dados3);
        Cliente c4 = new Cliente("thiago",dados3);
        Funcionario operador;
        Funcionario f1 = new Funcionario("gerente1",dados4,550.0f,
                                              Funcionario.GERENTE,"login1",
                                              "senha1");
        Funcionario f2 = new Funcionario("caixa1",dados1,200.0f,
                                              Funcionario.CAIXA,"login2",
                                              "senha2");
        Funcionario f3 = new Funcionario("caixa2",dados2,220.0f,
                                              Funcionario.CAIXA,"login3",
                                              "senha3");
        Funcionario f4 = new Funcionario("caixa2",dados1,0,Funcionario.CAIXA,
                                        "login2","senha2");
        Produto p1 = new Produto("Calabresa", "calabresa, queijo...",
                                Produto.TAMANHO_GRANDE, 17.0f);
        Produto p2 = new Produto("Coca-Cola", "Coca-Cola",
                                Produto.TAMANH0_LATA, 1.0f);
        Produto p3 = new Produto("Coca-Cola", "Coca-Cola trocada",
                                Produto.TAMANH0_LATA, 1.5f);
        rep1.inserir(p1);
        rep1.inserir(p2);
        Pedido pedido1 = new Pedido(0,c1,f2,rep1,3.0f);

        try {
            // Tenta entrar no sistema com senha errada
            operador = teste.fachada.login("gerente","senha_errada");
            // Tenta entrar no sistema com o login errado
            //operador = teste.fachada.login("login_errado","gerente");
        } catch (IllegalArgumentException e) {
            System.out.println(e.getMessage());
        }

        //Faz o login correto.
        operador = teste.fachada.login("gerente", "gerente");
        System.out.println("operador " + operador.getNome() + " logado.");

        //Coloca um funcionario do tipo Gerente na pizzaria
        teste.fachada.inserir(operador,f1);

        //Gerente recm-cadastrado faz login:
        operador = teste.fachada.login("login1","senha1");
        //Novo gerente insere dois funcionarios do tipo caixa
        teste.fachada.inserir(operador,f2);
        teste.fachada.inserir(operador,f3);

        //Gerente tenta cadastrar um cliente --- Da erro
        try {
        teste.fachada.inserir(operador,c1);
        } catch (IllegalArgumentException e) {
            System.out.println(e.getMessage());
        }
        //Caixa faz o login
        operador = teste.fachada.login("login2","senha2");

        //Caixa coloca 3 novos cliente na pizzaria
        teste.fachada.inserir(operador,c1);
        teste.fachada.inserir(operador,c2);
        teste.fachada.inserir(operador,c3);

        System.out.println("Cliente 2 antes da modificacao" + c2.toString());
        //Caixa atualiza o cliente c2 para c4
        teste.fachada.atualizar(operador,c4);
        System.out.println("Cliente 2 depois da modificacao" + c2.toString());

        //Caixa tenta colocar um cliente ja cadastrado
//        teste.fachada.inserir(c2);

        //Caixa coloca 2 produtos na pizzaria
//        teste.fachada.inserir(operador,p1);
//        teste.fachada.inserir(operador,p2);

        //Caixa cadastra um pedido
        teste.fachada.inserir(operador,pedido1);
        System.out.println(pedido1.toString());

        //Retirando p1 do pedido1 e imprimindo o pedido
        pedido1.getProdutos().remover(p1);
        System.out.println(pedido1.toString());


        //Um gerente troca a senha de um CAIXA
        operador = teste.fachada.login("login1","senha1");
        teste.fachada.trocaSenha(operador,f4,"nova_senha_do_caixa2");
        System.out.println(f2.getSenha());

        try {
            operador = teste.fachada.login("login2","nova_senha_do_caixa2");
        } catch (IllegalArgumentException e) {
            System.out.println(e.getMessage());
        }

        // imprime o produto p1:
        System.out.println(p1);
        // atualizar o produto p1 (trocar o tamanho para pequeno)
        p1.setTamanho(Produto.TAMANH0_PEQUENO);
/*        try {
            teste.fachada.atualizar(operador,p1);
        } catch (IllegalArgumentException e) {
            System.out.println(e.getMessage());
        } catch (PermissaoNegadaException ex) {
        }*/
        System.out.println(p1);

        //Atualiza um produto
//        teste.fachada.atualizar(operador,p3);
        System.out.println(p2.getNome() + p2.getDescricao() + p2.getPreco());
    }
}