package util;

/**
 * Title: Classe DadosResidenciais
 * Description: Negcio Bsico
 * Copyright:    Copyright (c) 2002
 * Company: VIP Team
 * @author Rafael Cavalcanti Ortolan
 * @version 1.0
 */

public class DadosResidenciais {


    private String endereco;
    private String telefone;
    private String bairro;
    private String referencia;
    private String cidade;

    /**
     * Construtor padro.
     */
    public DadosResidenciais() {
        endereco = new String("");
        telefone = new String("");
        bairro = new String("");
        referencia = new String("");
        cidade = new String("");
    }

    /**
     * Construtor.
     */
    public DadosResidenciais(String endereco, String telefone, String bairro,
        String referencia, String cidade) throws IllegalArgumentException {

        setEndereco(endereco);
        setTelefone(telefone);
        setBairro(bairro);
        setReferencia(referencia);
        setCidade(cidade);
    }

    /**
     * Retorna o atributo endereo.
     *
     * @return endereo.
     */
    public String getEndereco() {
        return endereco;
    }

    /**
     * Altera o endereo.
     *
     * @param endereco      novo endereo.
     */
    public void setEndereco(String endereco) {
        if (!endereco.equals("")) {
            this.endereco = endereco;
        } else {
            throw new IllegalArgumentException("Endereo invlido");
        }
    }

    /**
     * Retorna o atributo telenfone.
     *
     * @return telefone.
     */
    public String getTelefone() {
        return telefone;
    }

    /**
     * Altera o telefone.
     *
     * @param telefone      novo telefone.
     */
    public void setTelefone(String telefone) {
        if (!telefone.equals("")) {
            this.telefone = telefone;
        } else {
            throw new IllegalArgumentException("Telefone invlido");
        }
    }

    /**
     * Retorna o atributo bairro.
     *
     * @return bairro.
     */
    public String getBairro() {
        return bairro;
    }

    /**
     * Altera o bairro.
     *
     * @param bairro      novo bairro.
     */
    public void setBairro(String bairro) {
        if (!bairro.equals("")) {
            this.bairro = bairro;
        } else {
            throw new IllegalArgumentException("Bairro invlido");
        }
    }

    /**
     * Retorna o atributo cidade.
     *
     * @return cidade.
     */
    public String getCidade() {
        return cidade;
    }

    /**
     * Altera a cidade.
     *
     * @param cidade      nova cidade.
     */
    public void setCidade(String cidade) {
        if (!cidade.equals("")) {
            this.cidade = cidade;
        } else {
            throw new IllegalArgumentException("Cidade invlida");
        }
    }

    /**
     * Retorna o atributo referncia.
     *
     * @return referncia.
     */
    public String getReferencia() {
        return referencia;
    }

    /**
     * Altera a referncia.
     *
     * @param referncia      nova referncia.
     */
    public void setReferencia(String referencia) {
        this.referencia = referencia;
    }

    /**
     * Atualiza os dados residenciais de um funcionrio.
     *
     * @param d     dados residenciais que sero atualizados.
     */
    public void atualizar(DadosResidenciais d) throws IllegalArgumentException {
        setEndereco(d.getEndereco());
        setCidade(d.getCidade());
        setBairro(d.getBairro());
        setTelefone(d.getTelefone());
        setReferencia(d.getReferencia());
    }
}