package util;

/**
/**
 * Title: Classe IteratorArray
 * Description: Iterador.
 * Copyright: Copyright (c) 2002
 * Company: VIP Team
 * @author VIP Team
 * @version 1.0
 */

public class IteratorArray implements Iterator {

    private Object[] array;
    private int proximo;

     /**
     * Construtor da classe IteratorArray.
     *
     * @param l    Lista que o iterador vai usar.
     */
    public IteratorArray(Lista l) {
        int i;
        int j;

        proximo = 0;
        j = l.getTamanho();
        array = new Object[j];

        for (i = 0; i < j; i++) {
            array[i] = l.getNo();
            l = l.getProx();
        }
    }

    /**
     * Retorna um boolean dizendo se existe um proximo elemento.
     *
     * @return    boolean dizendo se existe um proximo elemento.
     */
    public boolean hasNext() {
        return (proximo < array.length);
    }

    /**
     * Retorna um object que representa o proximo elemento.
     *
     * @return    object que representa o proximo elemento.
     */
    public Object next() {
        proximo++;
        return array[proximo - 1];
    }
}